﻿----------------------------------------------------------------------------------------------------
-- DroodFocus 4.3.1 - config
-- Author : Meranannon - Discordia - Vol'jin (EU)
-- rev 5
----------------------------------------------------------------------------------------------------

DFREFS={}

DF_namespace.anchor={}

DF_namespace.practiceNotRunning=true
DF_namespace.practiceCheckBuff=true
DF_namespace.practiceCheckDebuff=true
DF_namespace.practiceCheckAura=false
DF_namespace.currentCombos=0
DF_namespace.luaCodeSeleted=nil

DF_namespace.lock=true
DF_namespace.configmode=false
DF_namespace.currentTime=GetTime()
DF_namespace.playerId = nil
DF_namespace.playerClass = nil
DF_namespace.playerLevel = nil
DF_namespace.playerTalent = nil
DF_namespace.playerTalentName = nil
DF_namespace.playerpoint = nil
DF_namespace.myArgs = ""
DF_namespace.menace = 0
DF_namespace.position3d = nil

DF_namespace.configToLoad = nil
DF_namespace.AnimaticToLoad = nil
DF_namespace.haveTarget=nil

DF_namespace.wipespell = true

DF_namespace.environnement = getfenv(0)

DF_namespace.DefaultSpell={
	spellIDs="0",
	abiUserText="",
	positionx=64,
	positiony=64,
	width=32,
	height=32,
	sType="DebuffTarget",
	showcd=true,
	showdottimer=true,
	perso=true,
	combo=false,
	icon=0,
	abiInternalCD=0,
	timerbar=0,
	color={r=1,v=0,b=0,a=1},
	abiSound="",
	form={true,true,true,true,true,true,true,true},
	strongcheck=false,
	FX_enable=false,
	FX_stack=0,
	FX_name="Custom",
	FX_width=128,
	FX_height=128,
	FX_texture="Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
	FX_customtexture="",
	FX_mode="BLEND",
	FX_angle=0,
	FX_start_posx=0,
	FX_middle_posx=0,
	FX_end_posx=0,
	FX_start_posy=0,
	FX_middle_posy=0,
	FX_end_posy=0,
	FX_start_alpha=0,
	FX_middle_alpha=1,
	FX_end_alpha=0,
	FX_start_scale=0.5,
	FX_middle_scale=1,
	FX_end_scale=0.5,
	FX_start_width=1,
	FX_middle_width=1,
	FX_end_width=1,		
	FX_start_height=1,
	FX_middle_height=1,
	FX_end_height=1,
	FX_speed=40,
	FX_rotatespeed=0,
	FX_chakerpower=0,
	FX_pulsepowerX=0,
	FX_pulsespeedX=0,
	FX_pulsepowerY=0,
	FX_pulsespeedY=0,
	FX_pulsepowerZ=0,
	FX_pulsespeedZ=0,
	FX_timerenable=false,			
	FX_timerposx=0,
	FX_timerposy=0,
	FX_timersmall=true,
	FX_timerabove=false,
	FX_timerscale=0.40,
	FX_timeralpha=0.35,
	FX_textenabled=false,
	FX_fontPath="Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
	FX_textsize=12,
	FX_textColor={
		["a"] = 0.5,
		["r"] = 1,
		["v"] = 1,
		["b"] = 1,		
	},
	FX_textalign="CENTER",
	FX_textoffsetx=0,
	FX_textoffsety=-40,
	luaCode="",
	comboPoints=0,
	removable=true,
}

StaticPopupDialogs["WIPESPELLS"] = {
  text = DF_namespace.locale["loadconfigansw"],
  button1 = DF_namespace.locale["loadconfigkeep"],
  button2 = DF_namespace.locale["loadconfigdisc"],
	OnAccept = function()
		DF_namespace:config_Loadok(DF_namespace.configToLoad,false,false)
	end,
	OnCancel = function()
		DF_namespace:config_Loadok(DF_namespace.configToLoad,false,true)
	end,  
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
};

-- effacement valeur d'une table
function DF_namespace:clearTable(source,spellstoo)
	local function _clear(csource)
		for index, value in pairs(csource) do
			if type(csource[index]) ~= "table" then
				csource[index]=nil
			else
				if (tostring(index)~="spells" or (tostring(index)=="spells" and spellstoo==true)) then
					_clear(csource[index])
				end
			end
		end
	end
	_clear(source)
end

-- copy d'une table vers une autre
function DF_namespace:copyTable(source,destination,spellstoo)
	local function _copy(csource,cdestination)
		for index, value in pairs(csource) do
			if type(csource[index]) ~= "table" then
				cdestination[index]=csource[index]
			else
				if (tostring(index)~="spells" or (tostring(index)=="spells" and spellstoo==true)) then
					if cdestination[index]==nil or not cdestination[index] then
						cdestination[index]={}
					end
					_copy(csource[index],cdestination[index])
				end
			end
		end
	end
	
	_copy(source,destination)
	
end

function DF_namespace:deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end

	-- Compléte la configuration actuel avec les variables de la config par default
function DF_namespace:completeTable(tcurrent,tdefaut,force)
	local chemin="config"

	local function _check(current,defaut,chemin,force)
		--DF_namespace:debugLine("chemin ",chemin)
		for index, value in pairs(defaut) do
			if type(defaut[index]) ~= "table" then
				if current[index]==nil then
					current[index]=defaut[index]
					--DF_namespace:debugLine("SET "..tostring(index),defaut[index])
				end
			else
				if chemin~="config.spells" or force then
					if current[index]==nil or not current[index] then
						current[index]={}
						--DF_namespace:debugLine("INDEX "..tostring(index),true)
					end				
					_check(current[index],defaut[index],chemin.."."..tostring(index),force)
				end
			end
		end
	end
	_check(tcurrent,tdefaut,chemin,force)	
end

function DF_namespace:configSaved(name)
	local nbConf=getn(DF_saved_configs)
	for i = 1,nbConf do
		if DF_saved_configs[i].configname==name then
			return i
		end
	end
	
	return 0
	
end

function DF_namespace:configBuildin(name)
	local nbConf=getn(DF_pred_configs)
	for i = 1,nbConf do
		if DF_pred_configs[i].configname==name then
			return i
		end
	end
	
	return 0
	
end

function DF_namespace:config_Save(name)
	
	if not name then name=DF_config.configname end
	
	name=name:gsub("BuildIn", "User")
	DF_config.configname=name
	DF_config.configversion=DROODFOCUS_CONFIGVERSION
	conf = DF_namespace:configSaved(name)

	if conf==0 then
		conf=getn(DF_saved_configs)+1
		DF_saved_configs[conf] = {}
	end

	DF_config.configversion=DROODFOCUS_CONFIGVERSION

	DF_saved_configs[conf] = DF_namespace:deepcopy(DF_config)
	DF_saved_configs[conf].configname=name

	DF_namespace:options_SavedconfigLists()
	
	DEFAULT_CHAT_FRAME:AddMessage(DF_namespace.locale["saved"]..name)
	
end

function DF_namespace:config_Load(name,showconfig)

	if not name then name=DF_namespace.configToLoad end
	DF_namespace.configToLoad=name;
	
	StaticPopup_Show("WIPESPELLS");

end

function DF_namespace:config_Loadok(name,showconfig,wipespell)

	DF_namespace:hide_ooc_frame()
	
	if not name then name=DF_namespace.configToLoad end
	
	if string.find(name, "BuildIn") then
		conf = DF_namespace:configBuildin(name)
		if conf~=0 then
			
			if (wipespell==true) then
				while getn(DF_config.spells)>getn(DF_pred_configs[conf].spells) do
					table.remove(DF_config.spells,getn(DF_config.spells))
				end
			end
			
			DF_namespace:options_hide()
			DF_namespace:clearTable(DF_config,wipespell)
			DF_namespace:copyTable(DF_pred_configs[conf],DF_config,wipespell)

			DF_namespace:completeTable(DF_config,DF_pred_configs[1],false)
			DF_namespace:updateTable()
			
			DF_namespace:init_frames()
			DF_namespace:toggle_toggle()
			DF_MinimapToggle()
			DEFAULT_CHAT_FRAME:AddMessage(DF_namespace.locale["loaded"]..DF_config.configname)
			
			if (showconfig==true) then
				DF_namespace:options_hide("DFOPTIONSelement");
				DF_namespace:options_show("DFOPTIONSelement")
			end
			
			DF_namespace.environnement["DFconfignamebox"]:Hide()
			DF_namespace.environnement["DFconfignamebox"]:Show()		
			DF_config.configversion=DROODFOCUS_CONFIGVERSION
			return
		end
	else
		conf = DF_namespace:configSaved(name)
		if conf~=0 then

			if (wipespell==true) then
				while getn(DF_config.spells)>getn(DF_saved_configs[conf].spells) do
					table.remove(DF_config.spells,getn(DF_config.spells))
				end
			end
			
			DF_namespace:options_hide()
			
			DF_namespace:clearTable(DF_config,wipespell)
			DF_namespace:copyTable(DF_saved_configs[conf],DF_config,wipespell)

			DF_namespace:completeTable(DF_config,DF_pred_configs[1],false)
			DF_namespace:updateTable()
			
			DF_namespace:init_frames()
			DF_namespace:toggle_toggle()
			DF_MinimapToggle()
			DEFAULT_CHAT_FRAME:AddMessage(DF_namespace.locale["loaded"]..DF_config.configname)
			
			if (showconfig==true) then
				DF_namespace:options_hide("DFOPTIONSelement");
				DF_namespace:options_show("DFOPTIONSelement")
			end
			
			DF_namespace.environnement["DFconfignamebox"]:Hide()
			DF_namespace.environnement["DFconfignamebox"]:Show()		
			DF_config.configversion=DROODFOCUS_CONFIGVERSION
			return
		end
	end
	
end

function DF_namespace:config_delete(numero)
	table.remove(DF_saved_configs,numero)
	DF_namespace:options_SavedconfigLists()
end

function DF_namespace:config_Reset()

	DF_namespace:hide_ooc_frame()

	while getn(DF_config.spells)>getn(DF_pred_configs[1].spells) do
		table.remove(DF_config.spells,getn(DF_config.spells))
	end

	DF_namespace:options_hide()
	
	DF_namespace:clearTable(DF_config,true)
	DF_namespace:copyTable(DF_pred_configs[1],DF_config,true)
	DF_namespace:completeTable(DF_config,DF_pred_configs[1],false)
	DF_namespace:updateTable()
	
	DF_namespace:init_frames()
	DF_namespace:toggle_toggle()
	DF_namespace.environnement["DFconfignamebox"]:Hide()
	DF_namespace.environnement["DFconfignamebox"]:Show()
	DF_namespace.environnement["dfcombat"]:Hide()
	DF_namespace.environnement["dfcombat"]:Show()
	DEFAULT_CHAT_FRAME:AddMessage(DF_namespace.locale["reset"])
	DF_config.configversion=DROODFOCUS_CONFIGVERSION
end

function DF_namespace:updateTable()

	-- mise a jour des positions des ancres par rapport a l'ancre global
	-- (pas de changement sur les version supérieure a la 4.1.5)
	if tonumber(DF_config.configversion)<415 then

		-- position de l'ancre 1
		tempx=DF_config["anchor1"].positionx
		tempy=DF_config["anchor1"].positiony	

		-- initialisation de l'ancre 0 a coté de l'ancre 1
		DF_config["anchor0"].positionx = tempx-32
		DF_config["anchor0"].positiony = tempy+32
		globalx=DF_config["anchor0"].positionx
		globaly=DF_config["anchor0"].positiony
		
		nbAnchors = 7
		-- replacement des ancre 1 a 7 par rapport a l'ancre 0		
		for i = 1,nbAnchors do
			
			tempx=DF_config["anchor"..tostring(i)].positionx
			tempy=DF_config["anchor"..tostring(i)].positiony
			
			if (tempx==0 and tempy==0) then
				DF_config["anchor"..tostring(i)].positionx = -200
				DF_config["anchor"..tostring(i)].positiony = 0
			else
				DF_config["anchor"..tostring(i)].positionx = (tempx-globalx)
				DF_config["anchor"..tostring(i)].positiony = (tempy-globaly)
			end
			
		end

		DF_config["anchor0"].positionx = ( GetScreenWidth() * UIParent:GetEffectiveScale() )/2
		DF_config["anchor0"].positiony = ( GetScreenHeight() * UIParent:GetEffectiveScale() )/2

	end
	
	if tonumber(DF_config.configversion)<419 then
		
		-- ajout auto de l'effet special OOC
		if DF_config.ooc.enable then

			table.insert(DF_config.spells, 1, {})
			DF_namespace:copyTable(DF_namespace.DefaultSpell,DF_config.spells[1],true)
			
			DF_config.spells[1].spellIDs="16870"
			DF_config.spells[1].sType="BuffPlayer"
			DF_config.spells[1].icon=0
			DF_config.spells[1].timerbar=0
			
			DF_config.spells[1].FX_enable=true
			DF_config.spells[1].FX_positionx=DF_config.ooc.positionx
			DF_config.spells[1].FX_positiony=DF_config.ooc.positiony
			DF_config.spells[1].FX_width=DF_config.ooc.width
			DF_config.spells[1].FX_height=DF_config.ooc.height
			DF_config.spells[1].FX_level=DF_config.ooc.level
			DF_config.spells[1].FX_mode=DF_config.ooc.mode
			DF_config.spells[1].FX_texture="Interface\\AddOns\\DroodFocus\\datas\\fx_ooc.tga"

			DF_config.spells[1].FX_start_scale=2.5
			DF_config.spells[1].FX_middle_scale=1.25
			DF_config.spells[1].FX_end_scale=2.5

			DF_config.spells[1].FX_start_posx=0
			DF_config.spells[1].FX_middle_posx=0
			DF_config.spells[1].FX_end_posx=0
			
			DF_config.spells[1].FX_start_posy=0
			DF_config.spells[1].FX_middle_posy=0
			DF_config.spells[1].FX_end_posy=0	

			DF_config.spells[1].FX_start_alpha=0
			DF_config.spells[1].FX_middle_alpha=1
			DF_config.spells[1].FX_end_alpha=0

			DF_config.spells[1].FX_speed=40

			DF_config.spells[1].FX_rotatespeed=0.5
			DF_config.spells[1].FX_chakerpower=1
			
		end
		
	end

	if tonumber(DF_config.configversion)<427 then

		DF_config.timerbars[1].width=DF_config.timerbar.width
		DF_config.timerbars[1].height=DF_config.timerbar.height
		DF_config.timerbars[1].texturePath=DF_config.timerbar.texturePath
		DF_config.timerbars[1].font1Path=DF_config.timerbar.font1Path
		DF_config.timerbars[1].font1Size=DF_config.timerbar.font1Size
		DF_config.timerbars[1].font2Path=DF_config.timerbar.font2Path
		DF_config.timerbars[1].font2Size=DF_config.timerbar.font2Size
		DF_config.timerbars[1].activeAlpha=DF_config.timerbar.activeAlpha
		DF_config.timerbars[1].inactiveAlpha=DF_config.timerbar.inactiveAlpha
		DF_config.timerbars[1].border=DF_config.timerbar.border
		DF_config.timerbars[1].borderSize=DF_config.timerbar.borderSize
		DF_config.timerbars[1].timeline=DF_config.timerbar.timeline
		DF_config.timerbars[1].prop=DF_config.timerbar.prop
		DF_config.timerbars[1].orderByTime=DF_config.timerbar.orderByTime
		DF_config.timerbars[1].level=DF_config.timerbar.level
		DF_config.timerbars[1].growup=DF_config.timerbar.growup
		DF_config.timerbars[1].stackup1=DF_config.timerbar.stackup1
		DF_config.timerbars[1].showSpark=DF_config.timerbar.showSpark
		DF_config.timerbars[1].activeAlphaCD=DF_config.timerbar.activeAlphaCD
		DF_config.timerbars[1].cdoffsety=DF_config.timerbar.cdoffsety
		DF_config.timerbars[1].textColor.a=DF_config.timerbar.textColor.a
		DF_config.timerbars[1].textColor.r=DF_config.timerbar.textColor.r
		DF_config.timerbars[1].textColor.v=DF_config.timerbar.textColor.v
		DF_config.timerbars[1].textColor.b=DF_config.timerbar.textColor.b
		DF_config.timerbars[1].borderColor.a=DF_config.timerbar.borderColor.a
		DF_config.timerbars[1].borderColor.r=DF_config.timerbar.borderColor.r
		DF_config.timerbars[1].borderColor.v=DF_config.timerbar.borderColor.v
		DF_config.timerbars[1].borderColor.b=DF_config.timerbar.borderColor.b
		DF_config.timerbars[1].cdColor.a=DF_config.timerbar.cdColor.a
		DF_config.timerbars[1].cdColor.r=DF_config.timerbar.cdColor.r
		DF_config.timerbars[1].cdColor.v=DF_config.timerbar.cdColor.v
		DF_config.timerbars[1].cdColor.b=DF_config.timerbar.cdColor.b
		DF_config.timerbars[1].textsoffsets[1].offsetx=DF_config.timerbar.textsoffsets[1].offsetx
		DF_config.timerbars[1].textsoffsets[1].offsety=DF_config.timerbar.textsoffsets[1].offsety
		DF_config.timerbars[1].textsoffsets[2].offsetx=DF_config.timerbar.textsoffsets[2].offsetx
		DF_config.timerbars[1].textsoffsets[2].offsety=DF_config.timerbar.textsoffsets[2].offsety

		DF_config.timerbars[2].width=DF_config.timerbar.width2
		DF_config.timerbars[2].height=DF_config.timerbar.height2
		DF_config.timerbars[2].texturePath=DF_config.timerbar.texturePath
		DF_config.timerbars[2].font1Path=DF_config.timerbar.font1Path
		DF_config.timerbars[2].font1Size=DF_config.timerbar.font1Size
		DF_config.timerbars[2].font2Path=DF_config.timerbar.font2Path
		DF_config.timerbars[2].font2Size=DF_config.timerbar.font2Size
		DF_config.timerbars[2].activeAlpha=DF_config.timerbar.activeAlpha2
		DF_config.timerbars[2].inactiveAlpha=DF_config.timerbar.inactiveAlpha2
		DF_config.timerbars[2].border=DF_config.timerbar.border
		DF_config.timerbars[2].borderSize=DF_config.timerbar.borderSize
		DF_config.timerbars[2].timeline=DF_config.timerbar.timeline
		DF_config.timerbars[2].prop=DF_config.timerbar.prop2
		DF_config.timerbars[2].orderByTime=DF_config.timerbar.orderByTime
		DF_config.timerbars[2].level=DF_config.timerbar.level
		DF_config.timerbars[2].growup=DF_config.timerbar.growup
		DF_config.timerbars[2].stackup1=DF_config.timerbar.stackup2
		DF_config.timerbars[2].showSpark=DF_config.timerbar.showSpark
		DF_config.timerbars[2].activeAlphaCD=DF_config.timerbar.activeAlphaCD2
		DF_config.timerbars[2].cdoffsety=DF_config.timerbar.cdoffsety
		DF_config.timerbars[2].textColor.a=DF_config.timerbar.textColor.a
		DF_config.timerbars[2].textColor.r=DF_config.timerbar.textColor.r
		DF_config.timerbars[2].textColor.v=DF_config.timerbar.textColor.v
		DF_config.timerbars[2].textColor.b=DF_config.timerbar.textColor.b
		DF_config.timerbars[2].borderColor.a=DF_config.timerbar.borderColor.a
		DF_config.timerbars[2].borderColor.r=DF_config.timerbar.borderColor.r
		DF_config.timerbars[2].borderColor.v=DF_config.timerbar.borderColor.v
		DF_config.timerbars[2].borderColor.b=DF_config.timerbar.borderColor.b
		DF_config.timerbars[2].cdColor.a=DF_config.timerbar.cdColor.a
		DF_config.timerbars[2].cdColor.r=DF_config.timerbar.cdColor.r
		DF_config.timerbars[2].cdColor.v=DF_config.timerbar.cdColor.v
		DF_config.timerbars[2].cdColor.b=DF_config.timerbar.cdColor.b
		DF_config.timerbars[2].textsoffsets[1].offsetx=DF_config.timerbar.textsoffsets[1].offsetx
		DF_config.timerbars[2].textsoffsets[1].offsety=DF_config.timerbar.textsoffsets[1].offsety
		DF_config.timerbars[2].textsoffsets[2].offsetx=DF_config.timerbar.textsoffsets[2].offsetx
		DF_config.timerbars[2].textsoffsets[2].offsety=DF_config.timerbar.textsoffsets[2].offsety

		DF_config.iconbars[1].fontSize=DF_config.icons.fontSize
		DF_config.iconbars[1].orderByTime=DF_config.icons.orderByTime
		DF_config.iconbars[1].decimal=DF_config.icons.decimal
		DF_config.iconbars[1].automatic=DF_config.icons.automatic
		DF_config.iconbars[1].showSpiral=DF_config.icons.showSpiral
		DF_config.iconbars[1].inactiveAlpha=DF_config.icons.inactiveAlpha
		DF_config.iconbars[1].level=DF_config.icons.level
		DF_config.iconbars[1].textsoffsets[1].visible=DF_config.icons.textsoffsets[1].visible
		DF_config.iconbars[1].textsoffsets[1].offsety=DF_config.icons.textsoffsets[1].offsety
		DF_config.iconbars[1].textsoffsets[1].align=DF_config.icons.textsoffsets[1].align
		DF_config.iconbars[1].textsoffsets[1].offsetx=DF_config.icons.textsoffsets[1].offsetx
		DF_config.iconbars[1].textsoffsets[1].size=DF_config.icons.textsoffsets[1].size
		DF_config.iconbars[1].textsoffsets[2].visible=DF_config.icons.textsoffsets[2].visible
		DF_config.iconbars[1].textsoffsets[2].offsety=DF_config.icons.textsoffsets[2].offsety
		DF_config.iconbars[1].textsoffsets[2].align=DF_config.icons.textsoffsets[2].align
		DF_config.iconbars[1].textsoffsets[2].offsetx=DF_config.icons.textsoffsets[2].offsetx
		DF_config.iconbars[1].textsoffsets[2].size=DF_config.icons.textsoffsets[2].size
		DF_config.iconbars[1].textsoffsets[3].visible=DF_config.icons.textsoffsets[3].visible
		DF_config.iconbars[1].textsoffsets[3].offsety=DF_config.icons.textsoffsets[3].offsety
		DF_config.iconbars[1].textsoffsets[3].align=DF_config.icons.textsoffsets[3].align
		DF_config.iconbars[1].textsoffsets[3].offsetx=DF_config.icons.textsoffsets[3].offsetx
		DF_config.iconbars[1].textsoffsets[3].size=DF_config.icons.textsoffsets[3].size
		DF_config.iconbars[1].colonne=DF_config.icons.colonne
		DF_config.iconbars[1].fontPath=DF_config.icons.fontPath
		DF_config.iconbars[1].mode=DF_config.icons.mode
		DF_config.iconbars[1].pointpa=DF_config.icons.pointpa
		DF_config.iconbars[1].width=DF_config.icons.width
		DF_config.iconbars[1].height=DF_config.icons.height
		DF_config.iconbars[1].speed=DF_config.icons.speed
		DF_config.iconbars[1].pulse=DF_config.icons.pulse
		DF_config.iconbars[1].activeAlpha=DF_config.icons.activeAlpha
		DF_config.iconbars[1].growup=DF_config.icons.growup
		DF_config.iconbars[1].textColor.a=DF_config.icons.textColor.a
		DF_config.iconbars[1].textColor.r=DF_config.icons.textColor.r
		DF_config.iconbars[1].textColor.v=DF_config.icons.textColor.v
		DF_config.iconbars[1].textColor.b=DF_config.icons.textColor.b

		DF_config.iconbars[2].fontSize=DF_config.icons.fontSize
		DF_config.iconbars[2].orderByTime=DF_config.icons.orderByTime
		DF_config.iconbars[2].decimal=DF_config.icons.decimal
		DF_config.iconbars[2].automatic=DF_config.icons.automatic
		DF_config.iconbars[2].showSpiral=DF_config.icons.showSpiral
		DF_config.iconbars[2].inactiveAlpha=DF_config.icons.inactiveAlpha
		DF_config.iconbars[2].level=DF_config.icons.level
		DF_config.iconbars[2].textsoffsets[1].visible=DF_config.icons.textsoffsets[1].visible
		DF_config.iconbars[2].textsoffsets[1].offsety=DF_config.icons.textsoffsets[1].offsety
		DF_config.iconbars[2].textsoffsets[1].align=DF_config.icons.textsoffsets[1].align
		DF_config.iconbars[2].textsoffsets[1].offsetx=DF_config.icons.textsoffsets[1].offsetx
		DF_config.iconbars[2].textsoffsets[1].size=DF_config.icons.textsoffsets[1].size
		DF_config.iconbars[2].textsoffsets[2].visible=DF_config.icons.textsoffsets[2].visible
		DF_config.iconbars[2].textsoffsets[2].offsety=DF_config.icons.textsoffsets[2].offsety
		DF_config.iconbars[2].textsoffsets[2].align=DF_config.icons.textsoffsets[2].align
		DF_config.iconbars[2].textsoffsets[2].offsetx=DF_config.icons.textsoffsets[2].offsetx
		DF_config.iconbars[2].textsoffsets[2].size=DF_config.icons.textsoffsets[2].size
		DF_config.iconbars[2].textsoffsets[3].visible=DF_config.icons.textsoffsets[3].visible
		DF_config.iconbars[2].textsoffsets[3].offsety=DF_config.icons.textsoffsets[3].offsety
		DF_config.iconbars[2].textsoffsets[3].align=DF_config.icons.textsoffsets[3].align
		DF_config.iconbars[2].textsoffsets[3].offsetx=DF_config.icons.textsoffsets[3].offsetx
		DF_config.iconbars[2].textsoffsets[3].size=DF_config.icons.textsoffsets[3].size
		DF_config.iconbars[2].colonne=DF_config.icons.colonne2
		DF_config.iconbars[2].fontPath=DF_config.icons.fontPath
		DF_config.iconbars[2].mode=DF_config.icons.mode
		DF_config.iconbars[2].pointpa=DF_config.icons.pointpa
		DF_config.iconbars[2].width=DF_config.icons.width2
		DF_config.iconbars[2].height=DF_config.icons.height2
		DF_config.iconbars[2].speed=DF_config.icons.speed
		DF_config.iconbars[2].pulse=DF_config.icons.pulse
		DF_config.iconbars[2].activeAlpha=DF_config.icons.activeAlpha
		DF_config.iconbars[2].growup=DF_config.icons.growup
		DF_config.iconbars[2].textColor.a=DF_config.icons.textColor.a
		DF_config.iconbars[2].textColor.r=DF_config.icons.textColor.r
		DF_config.iconbars[2].textColor.v=DF_config.icons.textColor.v
		DF_config.iconbars[2].textColor.b=DF_config.icons.textColor.b

		-- ajout gestion blood in the water
		table.insert(DF_config.spells, 1, {})
		DF_namespace:copyTable(DF_namespace.DefaultSpell,DF_config.spells[1],true)
		
		DF_config.spells[1].spellIDs="0"
		DF_config.spells[1].sType="Custom"
		DF_config.spells[1].abiUserText="Blood in the water"
	
		DF_config.spells[1].icon=0
		DF_config.spells[1].timerbar=0
		DF_config.spells[1].luaCode="current = UnitHealth(\"target\")\nmaxi = UnitHealthMax(\"target\")\npercent = current/maxi\nif percent<0.25 then\nreturn true\nelse\nreturn false\nend\n"	
		
		DF_config.spells[1].FX_enable=true
		DF_config.spells[1].FX_positionx=74
		DF_config.spells[1].FX_positiony=-38
		DF_config.spells[1].FX_width=128
		DF_config.spells[1].FX_height=128
		DF_config.spells[1].FX_level=127
		DF_config.spells[1].FX_mode="BLEND"
		DF_config.spells[1].FX_texture="Interface\\AddOns\\DroodFocus\\datas\\fx_glow10.tga"

		DF_config.spells[1].FX_start_scale=1.25
		DF_config.spells[1].FX_middle_scale=1.25
		DF_config.spells[1].FX_end_scale=1.25

		DF_config.spells[1].FX_start_posx=0
		DF_config.spells[1].FX_middle_posx=0
		DF_config.spells[1].FX_end_posx=-0
		
		DF_config.spells[1].FX_start_posy=250
		DF_config.spells[1].FX_middle_posy=0
		DF_config.spells[1].FX_end_posy=-65	

		DF_config.spells[1].FX_start_alpha=0
		DF_config.spells[1].FX_middle_alpha=0.65
		DF_config.spells[1].FX_end_alpha=0

		DF_config.spells[1].FX_start_height=0
		DF_config.spells[1].FX_middle_height=1
		DF_config.spells[1].FX_end_height=0.5

		DF_config.spells[1].FX_speed=5

		DF_config.spells[1].FX_pulsepowerZ=0.5
		DF_config.spells[1].FX_pulsespeedZ=2
		DF_config.spells[1].FX_rotatespeed=0
		DF_config.spells[1].FX_chakerpower=0		

	end

	if tonumber(DF_config.configversion)<429 then
		DF_config.iconbars[1].inactiveCDAlpha=DF_config.iconbars[1].inactiveAlpha
		DF_config.iconbars[2].inactiveCDAlpha=DF_config.iconbars[2].inactiveAlpha
	end

	if tonumber(DF_config.configversion)<430 then
 		anchorx=DF_config["anchor0"].positionx
 		anchory=DF_config["anchor0"].positiony		
 		oldx=DF_config.alert.positionx
 		oldy=DF_config.alert.positiony
 		DF_config.alert.positionx = anchorx+oldx
 		DF_config.alert.positiony = anchory+oldy
	end
		
end

function DF_namespace:config_getname(numero)
	if DF_saved_configs[numero] then
		return DF_saved_configs[numero].configname
	else
		return ""
	end
end
--
-- configurations prédéfinies
-- 
DF_pred_configs = {
	-- DEBUT [BuildIn] DroodFocus Default
	{
		["configversion"] = 433,
		["MiniMapAngle"] = 215.8160744865155,
		["portrait"] = {
			["textures"] = {
				"Interface\\AddOns\\DroodFocus\\datas\\empty.tga", -- [1]
				"Interface\\AddOns\\DroodFocus\\datas\\bearform.tga", -- [2]
				"Interface\\AddOns\\DroodFocus\\datas\\aquaform.tga", -- [3]
				"Interface\\AddOns\\DroodFocus\\datas\\catform.tga", -- [4]
				"Interface\\AddOns\\DroodFocus\\datas\\travelform.tga", -- [5]
				"Interface\\AddOns\\DroodFocus\\datas\\moonkinform.tga", -- [6]
				"Interface\\AddOns\\DroodFocus\\datas\\flightform.tga", -- [7]
				"Interface\\AddOns\\DroodFocus\\datas\\treeform.tga", -- [8]
			},
			[true] = 100,
			["positiony"] = -7.499752877781191,
			["enable"] = true,
			["width"] = 52,
			["height"] = 52,
			["mode"] = "ADD",
			["level"] = 5,
			["positionx"] = 0,
		},
		["powerbar"] = {
			["fontSize"] = 17,
			["positiony"] = -18.5,
			["enable"] = true,
			["border"] = true,
			["borderSize"] = 1,
			["colorNrj"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 1,
			},
			["texty"] = -0.5,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["interval"] = 1,
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["colorDef"] = {
				["a"] = 1,
				["b"] = 0.5,
				["v"] = 0.5,
				["r"] = 0.5,
			},
			["sformat"] = "#c",
			["positionx"] = 10,
			["orientation"] = "HORIZONTAL",
			["enableArrows"] = true,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["colorRage"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["colorMana"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 0,
				["r"] = 0,
			},
			["arrows"] = {
				33876, -- [1]
				5221, -- [2]
				80, -- [3]
				1079, -- [4]
				-1, -- [5]
				-1, -- [6]
			},
			["width"] = 192,
			["showText"] = true,
			["textx"] = -4,
			["height"] = 32,
			["textAlign"] = "RIGHT",
			["showSpark"] = true,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["threatbar"] = {
			["fontSize"] = 8,
			["positiony"] = -63,
			["enable"] = true,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 3,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#c%",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["textx"] = -4,
			["width"] = 192,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 8,
			["texty"] = 0,
			["positionx"] = 10,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["gridSizeX"] = 1,
		["optionsScale"] = 0.85,
		["sound"] = {
			["enable"] = true,
			["soundfiles"] = {
				"", -- [1]
				"Sound\\Spells\\Druid_Pounce.wav", -- [2]
				"", -- [3]
				"Sound\\Spells\\Druid_FeralCharge.wav", -- [4]
				"", -- [5]
				"", -- [6]
				"", -- [7]
				"", -- [8]
			},
		},
		["timelines"] = {
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["enable"] = false,
			["activeAlpha"] = 0.1,
			["width"] = 1,
		},
		["activeForms"] = {
			false, -- [1]
			true, -- [2]
			false, -- [3]
			true, -- [4]
			false, -- [5]
			false, -- [6]
			false, -- [7]
			false, -- [8]
		},
		["anchor5"] = {
			["visible"] = true,
			["positiony"] = -263,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "INFOS",
			["positionx"] = 752,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor3"] = {
			["visible"] = true,
			["positiony"] = -89,
			["scale"] = 0.75,
			["width"] = 32,
			["info"] = "TIMERBARS 1",
			["positionx"] = 206,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["icons"] = {
			["fontSize"] = 13,
			["orderByTime"] = true,
			["decimal"] = false,
			["automatic"] = true,
			["showSpiral"] = 1,
			["inactiveAlpha"] = 0.3,
			["level"] = 10,
			["height2"] = 37,
			["colonne2"] = 8,
			["textsoffsets"] = {
				{
					["visible"] = true,
					["offsety"] = -2,
					["align"] = "TOP",
					["offsetx"] = 0,
					["size"] = 14,
				}, -- [1]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMRIGHT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [2]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMLEFT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [3]
			},
			["mode"] = "BLEND",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["growup"] = false,
			["pointpa"] = true,
			["width"] = 37,
			["height"] = 37,
			["pulse"] = 1.6,
			["enable"] = true,
			["activeAlpha"] = 1,
			["width2"] = 37,
			["speed"] = 4,
			["colonne"] = 8,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["blood"] = {
			["persistence"] = 6,
			["level"] = 1,
			["NotInRaid"] = true,
			["enable"] = true,
			["mode"] = "BLEND",
			["alpha"] = 0.7,
			["size"] = 0.7,
		},
		["anchor4"] = {
			["visible"] = true,
			["positiony"] = -4,
			["scale"] = 0.75,
			["width"] = 32,
			["info"] = "TIMERBARS 2",
			["positionx"] = 206,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["reportkickchan"] = "NONE",
		["anchor7"] = {
			["visible"] = true,
			["positiony"] = -145,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "ICONS 2",
			["positionx"] = 229,
			["height"] = 32,
			["level"] = 1,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["haveTarget"] = false,
		["alignToGrid"] = true,
		["inCombat"] = false,
		["configname"] = "[BuildIn] Default (LowRes)",
		["roundMethod"] = true,
		["combo"] = {
			["fontSize"] = 18,
			["positiony"] = 0,
			["enable"] = true,
			["textOffsetX"] = 12,
			["impulsion"] = 1.2,
			["level"] = 12,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\combo.tga",
			["textures"] = {
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_gray.tga", -- [1]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_yellow.tga", -- [2]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_gray.tga", -- [3]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_red.tga", -- [4]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga", -- [5]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_rune_blood.tga", -- [6]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga", -- [7]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_rune_frost.tga", -- [8]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga", -- [9]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_rune_unholy.tga", -- [10]
				[13] = "Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga",
				[14] = "Interface\\AddOns\\DroodFocus\\custom\\combo_holy.tga",
			},
			["angleA"] = 288,
			["offsety"] = 0,
			["ptype"] = 1,
			["angleB"] = 183,
			["form"] = {
				false, -- [1]
				true, -- [2]
				false, -- [3]
				true, -- [4]
				false, -- [5]
				false, -- [6]
				false, -- [7]
			},
			["mode"] = "BLEND",
			["width"] = 43,
			["offsetx"] = 38,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showText"] = false,
			["textOffsetY"] = -17,
			["height"] = 19,
			["positionx"] = 5,
			["rayon"] = 37,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["anchor0"] = {
			["visible"] = true,
			["positiony"] = 289,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "GLOBAL",
			["positionx"] = 625,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["cooldown"] = {
			["offsety"] = -48,
			["positiony"] = -1.000137314198355,
			["enable"] = true,
			["alpha"] = 0.7,
			["width"] = 49,
			["positionx"] = 199.9999970197678,
			["mode"] = "BLEND",
			["height"] = 49,
			["level"] = 5,
			["offsetx"] = 0,
			["temps"] = 3,
		},
		["anchor6"] = {
			["visible"] = true,
			["positiony"] = -39,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "CD",
			["level"] = 10,
			["height"] = 32,
			["positionx"] = -4,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["reportkick"] = true,
		["targetbar"] = {
			["fontSize"] = 9,
			["positiony"] = -50,
			["enable"] = true,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#M k (#p%) #t",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["textx"] = -4,
			["width"] = 192,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.75,
				["r"] = 1,
			},
			["positionx"] = 10,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 13,
			["texty"] = 0,
			["textAlign"] = "RIGHT",
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["infos"] = {
			["fontSize"] = 8,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["infolines"] = "PA: #meleeAP (#maxAP)*CC: #meleeCrit (#maxCrit%)*HASTE: #meleeHaste",
			["enable"] = false,
			["level"] = 12,
			["backColor"] = {
				["a"] = 0,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["textColor"] = {
				["a"] = 0.4600000381469727,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["minimap"] = true,
		["anchor2"] = {
			["visible"] = true,
			["positiony"] = -5,
			["scale"] = 0.8,
			["width"] = 32,
			["info"] = "ICONS 1",
			["level"] = 1,
			["height"] = 32,
			["positionx"] = 50,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["fixrip"] = false,
		["uiAlwaysShow"] = false,
		["timerbar"] = {
			["activeAlpha"] = 1,
			["cdColor"] = {
				["a"] = 0.4900000095367432,
				["b"] = 0,
				["v"] = 1,
				["r"] = 1,
			},
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["inactiveAlpha"] = 0,
			["level"] = 4,
			["height2"] = "22",
			["prop2"] = true,
			["growup"] = false,
			["font1Size"] = 12,
			["timeline"] = 14,
			["cdoffsety"] = 2,
			["height"] = "22",
			["activeAlpha2"] = 1,
			["orderByTime"] = true,
			["enable"] = true,
			["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showSpark"] = true,
			["prop"] = true,
			["borderSize"] = 1,
			["activeAlphaCD"] = 1,
			["cdoffsetx"] = 0,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["textsoffsets"] = {
				{
					["offsety"] = 1,
					["offsetx"] = 0,
				}, -- [1]
				{
					["offsety"] = 0,
					["offsetx"] = 2,
				}, -- [2]
			},
			["activeAlphaCD2"] = 1,
			["stackup2"] = true,
			["width"] = "257.25",
			["inactiveAlpha2"] = 0,
			["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["stackup1"] = false,
			["font2Size"] = 20,
			["width2"] = "257.25",
			["showTimeLine"] = true,
			["border"] = true,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["gridSizeY"] = 1,
		["gps"] = {
			["fontSize"] = 10,
			["gpsTarget"] = {
				"target", -- [1]
				"focus", -- [2]
			},
			["positiony"] = 202.6987448411231,
			["enable"] = true,
			["offsety"] = -16,
			["alpha"] = 1,
			["width"] = 28,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["positionx"] = 0,
			["level"] = 10,
			["mode"] = "BLEND",
			["height"] = 28,
			["offsetx"] = 0,
			["positions"] = {
				{
					["y"] = 114.1027500492217,
					["x"] = 755.2753778377884,
				}, -- [1]
				{
					["y"] = 137.7306397605736,
					["x"] = 662.8310612926789,
				}, -- [2]
				{
				}, -- [3]
			},
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["anchor1"] = {
			["visible"] = true,
			["positiony"] = -36,
			["scale"] = 0.8,
			["width"] = 32,
			["info"] = "UI",
			["mode"] = "BLEND",
			["height"] = 32,
			["level"] = 1,
			["positionx"] = 48,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["defensebar"] = {
			["fontSize"] = 11,
			["positiony"] = 97,
			["enable"] = true,
			["border"] = false,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar5.tga",
			["sformat"] = "#C k/#M k",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				false, -- [1]
				true, -- [2]
				false, -- [3]
				false, -- [4]
				false, -- [5]
				false, -- [6]
				false, -- [7]
				false, -- [8]
			},
			["color"] = {
				["a"] = 0.7900000065565109,
				["b"] = 0.9686274509803922,
				["v"] = 1,
				["r"] = 0.5372549019607843,
			},
			["width"] = 149,
			["textx"] = -4,
			["positionx"] = 29,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 20,
			["texty"] = -1,
			["textAlign"] = "CENTER",
			["textColor"] = {
				["a"] = 1,
				["b"] = 0.7803921568627451,
				["v"] = 0.7803921568627451,
				["r"] = 0.7803921568627451,
			},
		},
		["castbar"] = {
			["positiony"] = 77,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["activeAlpha"] = 1,
			["timerAlign"] = "RIGHT",
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["inactiveAlpha"] = 0,
			["level"] = 3,
			["timery"] = 0,
			["textx"] = 3,
			["sound1"] = "Interface\\AddOns\\DroodFocus\\datas\\DF_alert.ogg",
			["showText"] = true,
			["height"] = 24,
			["positionx"] = 10,
			["sound2"] = "",
			["fontSize"] = 12,
			["colori"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["enable"] = true,
			["timerx"] = -3,
			["borderSize"] = 2,
			["fontPathtimer"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["timerColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showTimer"] = true,
			["textAlign"] = "LEFT",
			["width"] = 192,
			["showSpark"] = true,
			["impulsion"] = 1,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["fontSizetimer"] = 16,
			["orientation"] = "HORIZONTAL",
			["texty"] = 0,
			["border"] = true,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["manabar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 0,
				["r"] = 0,
			},
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["enable"] = false,
			["width"] = 192,
			["textx"] = -7,
			["positionx"] = 8,
			["showText"] = true,
			["height"] = 18,
			["orientation"] = "HORIZONTAL",
			["texty"] = 1,
			["textAlign"] = "RIGHT",
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["spells"] = {
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 77758,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "77758",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["ids"] = {
					77758, -- [1]
				},
				["FX_textoffsetx"] = 0,
				["FX_timerposy"] = 0,
				["abiSpelltext"] = "Rosser",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_rotatespeed"] = 0,
				["FX_timersmall"] = true,
				["abiEnd"] = 0,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["FX_textalign"] = "CENTER",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["strongcheck"] = false,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_start_height"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_customtexture"] = "",
				["names"] = {
					"Rosser", -- [1]
				},
				["FX_timerenable"] = false,
				["abiFake"] = 0,
				["showdottimer"] = true,
				["FX_end_posx"] = 0,
				["FX_timeralpha"] = 0.35,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["comboPoints"] = 0,
				["height"] = 32,
				["abiRdyMode"] = false,
				["FX_middle_width"] = 1,
				["FX_end_scale"] = 0.5,
				["FX_start_scale"] = 0.5,
				["FX_textoffsety"] = -40,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_middle_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["abiLast"] = 0,
				["FX_start_posx"] = 0,
				["FX_start_posy"] = 0,
			}, -- [1]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 90166,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					90166, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "90166",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0.009999999998399289,
				["FX_chakerpower"] = 0,
				["FX_textenabled"] = false,
				["abiLast"] = 0,
				["FX_middle_scale"] = 1,
				["FX_start_posy"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_textalign"] = "CENTER",
				["FX_timersmall"] = true,
				["FX_rotatespeed"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_name"] = "Custom",
				["showdottimer"] = true,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_middle_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_start_height"] = 1,
				["names"] = {
					"Force de la panthère", -- [1]
				},
				["FX_stack"] = 0,
				["abiFake"] = 0,
				["FX_end_posx"] = 0,
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["height"] = 32,
				["abiRdyMode"] = false,
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_end_scale"] = 0.5,
				["abiDuration"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["abiEnd"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["abiSpelltext"] = "Force de la panthère",
				["FX_start_posx"] = 0,
				["FX_textoffsetx"] = 0,
			}, -- [2]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 92108,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 50,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = -23,
				["abiWarn"] = 6,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "92108;59520",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 45.40200000000004,
				["FX_chakerpower"] = 0,
				["timerbar"] = 2,
				["FX_height"] = 128,
				["abiSpelltext"] = "Carnage insouciant",
				["FX_start_posy"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["sType"] = "BuffPlayer",
				["FX_timersmall"] = true,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_start_alpha"] = 0,
				["FX_middle_posx"] = 0,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_timerposy"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textalign"] = "CENTER",
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["height"] = 32,
				["names"] = {
					"Carnage insouciant", -- [1]
					"Rafale d'eau", -- [2]
				},
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_customtexture"] = "",
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_rotatespeed"] = 0,
				["comboPoints"] = 0,
				["FX_end_scale"] = 0.5,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["perso"] = true,
				["FX_textoffsety"] = -40,
				["FX_start_scale"] = 0.5,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_end_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["ids"] = {
					92108, -- [1]
					59520, -- [2]
				},
				["abiLast"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 177,
			}, -- [3]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 92104,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["FX_customtexture"] = "",
				["positionx"] = 64,
				["FX_positionx"] = -23,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 2,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "92104",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 0.6078431372549019,
					["b"] = 1,
				},
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 5.716000000000122,
				["FX_chakerpower"] = 0,
				["FX_middle_scale"] = 1,
				["FX_timerscale"] = 0.4,
				["abiSpelltext"] = "Rivière de la mort",
				["FX_start_posy"] = 0,
				["ids"] = {
					92104, -- [1]
				},
				["FX_end_scale"] = 0.5,
				["sType"] = "BuffPlayer",
				["FX_timersmall"] = true,
				["showcd"] = true,
				["FX_name"] = "Custom",
				["FX_middle_posx"] = 0,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["abiEnd"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_end_posx"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["names"] = {
					"Rivière de la mort", -- [1]
				},
				["abiFake"] = 0,
				["perso"] = true,
				["abiDuration"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_timeralpha"] = 0.35,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["comboPoints"] = 0,
				["FX_stack"] = 0,
				["abiRdyMode"] = false,
				["FX_middle_width"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["combo"] = false,
				["FX_mode"] = "BLEND",
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["showdottimer"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_textoffsetx"] = 0,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 177,
			}, -- [4]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 69369,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 2,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "69369",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 8.120000000002619,
				["FX_chakerpower"] = 0,
				["FX_start_posy"] = 0,
				["TimerLimit"] = 0,
				["abiEnd"] = 0,
				["FX_customtexture"] = "",
				["FX_rotatespeed"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_textoffsetx"] = 0,
				["FX_timersmall"] = true,
				["FX_textalign"] = "CENTER",
				["FX_start_alpha"] = 0,
				["FX_start_height"] = 1,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["showcd"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_stack"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["names"] = {
					"Rapidité du prédateur", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_mode"] = "BLEND",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["ids"] = {
					69369, -- [1]
				},
				["FX_timeralpha"] = 0.35,
				["showdottimer"] = true,
				["comboPoints"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0.07450980392156863,
					["v"] = 1,
					["r"] = 0,
				},
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_middle_posx"] = 0,
				["combo"] = false,
				["abiDuration"] = 0,
				["form"] = {
					true, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_end_scale"] = 0.5,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["abiSpelltext"] = "Rapidité du prédateur",
				["FX_timerposy"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [5]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 50334,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 50,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["FX_positionx"] = 134,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Berserk",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_pulsespeedZ"] = 13.5,
				["FX_textenabled"] = true,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.55,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "50334",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 185.7220000000016,
				["FX_chakerpower"] = 1.75,
				["FX_start_posy"] = 0,
				["FX_rotatespeed"] = 0,
				["ids"] = {
					50334, -- [1]
				},
				["TimerLimit"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_end_scale"] = 0,
				["FX_textalign"] = "CENTER",
				["FX_timersmall"] = false,
				["FX_middle_posx"] = 0,
				["FX_name"] = "HeartBeat",
				["height"] = 32,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["abiEnd"] = 0,
				["FX_pulsepowerZ"] = 0.5,
				["FX_start_scale"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -36,
				["perso"] = true,
				["names"] = {
					"Berserk", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\custom\\lion",
				["FX_end_posx"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_timeralpha"] = 0.25,
				["FX_timerenable"] = false,
				["comboPoints"] = 0,
				["abiDuration"] = 0,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["abiLast"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_pulsepowerX"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_customtexture"] = "",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["timerbar"] = 1,
				["FX_middle_scale"] = 0.8,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 176,
			}, -- [6]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 5217,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 50,
				["FX_customtexture"] = "",
				["positionx"] = 64,
				["FX_positionx"] = 1,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_pulsespeedZ"] = 13.5,
				["FX_textenabled"] = true,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.55,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "5217",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 27.08099999999831,
				["FX_chakerpower"] = 1.75,
				["FX_rotatespeed"] = 0,
				["ids"] = {
					5217, -- [1]
				},
				["abiAlert"] = false,
				["FX_middle_scale"] = 0.8,
				["FX_middle_posx"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\custom\\paw",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timersmall"] = false,
				["FX_textoffsetx"] = 0,
				["FX_name"] = "Custom",
				["height"] = 32,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["showcd"] = true,
				["FX_pulsepowerZ"] = 0.5,
				["FX_start_scale"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -36,
				["FX_end_posx"] = 0,
				["names"] = {
					"Fureur du tigre", -- [1]
				},
				["abiFake"] = 0,
				["FX_timerenable"] = false,
				["sType"] = "BuffPlayer",
				["abiSpelltext"] = "Fureur du tigre",
				["FX_timeralpha"] = 0.25,
				["abiEnd"] = 0,
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = true,
				["FX_middle_width"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["abiDuration"] = 0,
				["timerbar"] = 1,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_end_scale"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_height"] = 128,
				["FX_textalign"] = "CENTER",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 176,
			}, -- [7]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 82365,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 1,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "82365",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_stack"] = 0,
				["FX_start_posy"] = 0,
				["FX_height"] = 128,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_pulsespeedZ"] = 0,
				["FX_timersmall"] = true,
				["FX_timerposy"] = 0,
				["FX_start_alpha"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 0.6862745098039216,
					["r"] = 0,
				},
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["ids"] = {
					82365, -- [1]
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_end_scale"] = 0.5,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["sType"] = "DebuffTarget",
				["names"] = {
					"Coup de crâne", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_start_height"] = 1,
				["FX_customtexture"] = "",
				["abiDuration"] = 0,
				["FX_timeralpha"] = 0.35,
				["FX_timerscale"] = 0.4,
				["comboPoints"] = 0,
				["FX_textoffsety"] = -40,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["FX_end_posx"] = 0,
				["combo"] = false,
				["height"] = 32,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["showcd"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_posx"] = 0,
				["abiSpelltext"] = "Coup de crâne",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [8]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 80951,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					80951, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "80951",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["abiSpelltext"] = "Pulvérisation",
				["timerbar"] = 0,
				["FX_start_posy"] = 0,
				["FX_pulsespeedZ"] = 0,
				["sType"] = "BuffPlayer",
				["FX_end_scale"] = 0.5,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timersmall"] = true,
				["FX_textenabled"] = false,
				["FX_start_alpha"] = 0,
				["abiLast"] = 0,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["showdottimer"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_rotatespeed"] = 0,
				["names"] = {
					"Pulvérisation", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_middle_posx"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_textoffsety"] = -40,
				["FX_mode"] = "BLEND",
				["FX_textalign"] = "CENTER",
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_scale"] = 1,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [9]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 5229,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["FX_customtexture"] = "",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Enrager",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "5229",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_start_posy"] = 0,
				["timerbar"] = 1,
				["FX_pulsespeedZ"] = 0,
				["TimerLimit"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 0.6862745098039216,
					["r"] = 0,
				},
				["FX_end_scale"] = 0.5,
				["abiEnd"] = 0,
				["FX_timersmall"] = true,
				["FX_pulsepowerX"] = 0,
				["FX_start_alpha"] = 0,
				["showdottimer"] = true,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_timerposy"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_mode"] = "BLEND",
				["names"] = {
					"Enrager", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_rotatespeed"] = 0,
				["combo"] = false,
				["perso"] = true,
				["FX_timeralpha"] = 0.35,
				["FX_start_scale"] = 0.5,
				["comboPoints"] = 0,
				["FX_textoffsety"] = -40,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiLast"] = 0,
				["FX_timerscale"] = 0.4,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_middle_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["sType"] = "BuffPlayer",
				["ids"] = {
					5229, -- [1]
				},
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [10]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 22812,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Ecorce",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "22812",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 72.80299999999988,
				["FX_chakerpower"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					22812, -- [1]
				},
				["FX_start_posy"] = 0,
				["TimerLimit"] = 0,
				["abiLast"] = 0,
				["FX_end_scale"] = 0.5,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timersmall"] = true,
				["timerbar"] = 1,
				["FX_start_alpha"] = 0,
				["FX_pulsepowerX"] = 0,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0.07450980392156863,
					["v"] = 1,
					["r"] = 0,
				},
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_timerposy"] = 0,
				["names"] = {
					"Ecorce", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_start_scale"] = 0.5,
				["FX_rotatespeed"] = 0,
				["FX_mode"] = "BLEND",
				["FX_timeralpha"] = 0.35,
				["combo"] = false,
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["FX_customtexture"] = "",
				["FX_textoffsety"] = -40,
				["FX_middle_posx"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_end_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["sType"] = "BuffPlayer",
				["FX_textalign"] = "CENTER",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [11]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 91565,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["abiSpelltext"] = "Feu féerique",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "91565;7386;8647;35387;50498;770",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["ids"] = {
					91565, -- [1]
					7386, -- [2]
					8647, -- [3]
					35387, -- [4]
					50498, -- [5]
					770, -- [6]
				},
				["FX_height"] = 128,
				["FX_start_posy"] = 0,
				["showcd"] = true,
				["timerbar"] = 2,
				["FX_end_scale"] = 0.5,
				["FX_middle_scale"] = 1,
				["FX_timersmall"] = true,
				["FX_rotatespeed"] = 0,
				["FX_start_alpha"] = 0,
				["height"] = 32,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["showdottimer"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_customtexture"] = "",
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["names"] = {
					"Feu féerique", -- [1]
					"Fracasser armure", -- [2]
					"Exposer l'armure", -- [3]
					"Crachat corrosif", -- [4]
					"Déchirer armure", -- [5]
					"Lucioles", -- [6]
				},
				["FX_middle_width"] = 1,
				["FX_pulsespeedZ"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_textoffsety"] = -40,
				["FX_timeralpha"] = 0.35,
				["abiEnd"] = 0,
				["comboPoints"] = 0,
				["abiDuration"] = 0,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["perso"] = true,
				["FX_timerenable"] = false,
				["FX_end_posx"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_pulsepowerX"] = 0,
				["FX_timerscale"] = 0.4,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [12]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 16,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 61336,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 0.5,
				["abiInternalCD"] = 0,
				["FX_speed"] = 60,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 69,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Instincts de survie",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = true,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "61336",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 2,
				["ids"] = {
					61336, -- [1]
				},
				["FX_timerscale"] = 0.55,
				["TimerLimit"] = 0,
				["FX_start_posy"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_end_scale"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx_glow7.tga",
				["FX_timersmall"] = false,
				["FX_middle_scale"] = 3,
				["FX_start_alpha"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["showdottimer"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_customtexture"] = "",
				["FX_pulsepowerZ"] = 0.2,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 1,
					["b"] = 0.07450980392156863,
				},
				["names"] = {
					"Instincts de survie", -- [1]
				},
				["FX_middle_width"] = 1,
				["perso"] = true,
				["combo"] = false,
				["abiDuration"] = 0,
				["FX_timeralpha"] = 0.25,
				["timerbar"] = 1,
				["comboPoints"] = 0,
				["FX_textoffsety"] = -47.5,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["height"] = 32,
				["FX_pulsespeedZ"] = 0,
				["FX_end_posx"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Explode",
				["abiLast"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["sType"] = "BuffPlayer",
				["FX_pulsepowerX"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 188,
			}, -- [13]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 81022,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 20,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 70,
				["abiWarn"] = 0,
				["FX_angle"] = 19,
				["TimerLimit"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 0.2,
				["FX_width"] = 160,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = true,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "81022",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiLast"] = 0,
				["FX_start_width"] = 0.2,
				["abiCD"] = 0,
				["abiLastCd"] = 28.1309999999994,
				["FX_chakerpower"] = 1,
				["FX_height"] = 160,
				["FX_rotatespeed"] = 0,
				["FX_customtexture"] = "",
				["FX_start_posy"] = 0,
				["FX_pulsespeedZ"] = 16,
				["FX_end_scale"] = 1,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timersmall"] = false,
				["ids"] = {
					81022, -- [1]
				},
				["FX_name"] = "FromRight",
				["showcd"] = true,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["sType"] = "BuffPlayer",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_timerscale"] = 0.85,
				["FX_pulsepowerZ"] = 0.2,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_middle_posx"] = 0,
				["names"] = {
					"Ruée", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_start_height"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\custom\\tiger",
				["abiDuration"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_timerposy"] = 0,
				["comboPoints"] = 0,
				["FX_textoffsety"] = -18,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_mode"] = "BLEND",
				["FX_timerenable"] = false,
				["timerbar"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_end_posx"] = -160,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["showdottimer"] = true,
				["abiSpelltext"] = "Ruée",
				["FX_start_posx"] = 160,
				["FX_positiony"] = 243,
			}, -- [14]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 16870,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 128,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["FX_positionx"] = 72,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 96,
				["abiSpelltext"] = "Idées claires",
				["FX_end_width"] = 1,
				["FX_width"] = 425,
				["FX_stack"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					16870, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "16870",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0.771999999999025,
				["FX_chakerpower"] = 1,
				["FX_start_posy"] = 0,
				["TimerLimit"] = 0,
				["FX_middle_scale"] = 1.75,
				["FX_pulsepowerX"] = 0,
				["FX_customtexture"] = "",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx_ooc.tga",
				["FX_middle_posx"] = 0,
				["FX_timersmall"] = true,
				["FX_textenabled"] = false,
				["FX_name"] = "Custom",
				["FX_start_height"] = 1,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_end_scale"] = 3,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textalign"] = "CENTER",
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["showdottimer"] = true,
				["names"] = {
					"Idées claires", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_mode"] = "ADD",
				["combo"] = false,
				["abiEnd"] = 0,
				["FX_timeralpha"] = 0.35,
				["abiLast"] = 0,
				["comboPoints"] = 0,
				["FX_start_scale"] = 0,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_textoffsety"] = -40,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["timerbar"] = 0,
				["form"] = {
					true, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					true, -- [6]
					false, -- [7]
					true, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_textoffsetx"] = 0,
				["FX_rotatespeed"] = 0.5,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 77,
			}, -- [15]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 33745,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["FX_customtexture"] = "",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					33745, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "33745",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_middle_scale"] = 1,
				["FX_textoffsetx"] = 0,
				["FX_start_posy"] = 0,
				["FX_height"] = 128,
				["abiLast"] = 0,
				["FX_end_scale"] = 0.5,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = true,
				["abiEnd"] = 0,
				["FX_name"] = "Custom",
				["showdottimer"] = true,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_textenabled"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_end_posx"] = 0,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = true,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_textalign"] = "CENTER",
				["names"] = {
					"Lacérer", -- [1]
				},
				["FX_middle_width"] = 1,
				["perso"] = true,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_stack"] = 0,
				["comboPoints"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_mode"] = "BLEND",
				["FX_start_scale"] = 0.5,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["sType"] = "DebuffTarget",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_rotatespeed"] = 0,
				["abiSpelltext"] = "Lacérer",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [16]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 33878,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "33878;33876;46857;50271;35290;16511",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Mutilation",
				["FX_textoffsetx"] = 0,
				["FX_start_posy"] = 0,
				["abiEnd"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["showcd"] = true,
				["FX_timersmall"] = true,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["FX_rotatespeed"] = 0,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_end_scale"] = 0.5,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_customtexture"] = "",
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_timerscale"] = 0.4,
				["names"] = {
					"Mutilation", -- [1]
					"Mutilation", -- [2]
					"Traumatisme", -- [3]
					"Déchirure du tendon", -- [4]
					"Encorner", -- [5]
					"Hémorragie", -- [6]
				},
				["FX_middle_width"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_mode"] = "BLEND",
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["perso"] = false,
				["comboPoints"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiDuration"] = 0,
				["FX_end_posx"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 26,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["showdottimer"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["ids"] = {
					33878, -- [1]
					33876, -- [2]
					46857, -- [3]
					50271, -- [4]
					35290, -- [5]
					16511, -- [6]
				},
				["FX_middle_scale"] = 1,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [17]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 22842,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Régénération frénétique",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 1,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "22842",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_start_posy"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_pulsepowerX"] = 0,
				["sType"] = "BuffPlayer",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["showcd"] = true,
				["FX_timersmall"] = true,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["ids"] = {
					22842, -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_middle_scale"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_start_scale"] = 0.5,
				["names"] = {
					"Régénération frénétique", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_end_scale"] = 0.5,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textalign"] = "CENTER",
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["FX_mode"] = "BLEND",
				["combo"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 1,
					["b"] = 0.07450980392156863,
				},
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_end_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_posx"] = 0,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [18]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1850,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = -23,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Célérité",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 1,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "1850",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["FX_pulsepowerX"] = 0,
				["sType"] = "BuffPlayer",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_end_posx"] = 0,
				["FX_timersmall"] = true,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["FX_middle_scale"] = 1,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_customtexture"] = "",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["combo"] = false,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["names"] = {
					"Célérité", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_mode"] = "BLEND",
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 1,
					["b"] = 0.07450980392156863,
				},
				["perso"] = true,
				["FX_timeralpha"] = 0.35,
				["FX_end_scale"] = 0.5,
				["comboPoints"] = 0,
				["FX_textalign"] = "CENTER",
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["abiDuration"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["showcd"] = true,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["ids"] = {
					1850, -- [1]
				},
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 177,
			}, -- [19]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 52610,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Rugissement sauvage",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "52610",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 22.40299999999843,
				["FX_chakerpower"] = 0,
				["FX_start_posy"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_end_posx"] = 0,
				["sType"] = "BuffPlayer",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["showcd"] = true,
				["FX_timersmall"] = true,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["ids"] = {
					52610, -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_middle_scale"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_start_scale"] = 0.5,
				["names"] = {
					"Rugissement sauvage", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_end_scale"] = 0.5,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textalign"] = "CENTER",
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["FX_start_height"] = 1,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["height"] = 32,
				["combo"] = false,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["showdottimer"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [20]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 99,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Rugissement démoralisant",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					99, -- [1]
					1160, -- [2]
					702, -- [3]
					26017, -- [4]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "99;1160;702;26017",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_start_posy"] = 0,
				["TimerLimit"] = 0,
				["sType"] = "DebuffTarget",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_textalign"] = "CENTER",
				["FX_timersmall"] = true,
				["FX_stack"] = 0,
				["FX_start_alpha"] = 0,
				["FX_end_posx"] = 0,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_end_scale"] = 0.5,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["combo"] = false,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textenabled"] = false,
				["names"] = {
					"Rugissement démoralisant", -- [1]
					"Cri démoralisant", -- [2]
					"Malédiction de faiblesse", -- [3]
					"Justification", -- [4]
				},
				["FX_middle_width"] = 1,
				["perso"] = true,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["showcd"] = true,
				["FX_timeralpha"] = 0.35,
				["FX_middle_posx"] = 0,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_textoffsety"] = -40,
				["height"] = 32,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_customtexture"] = "",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_scale"] = 1,
				["FX_pulsepowerX"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [21]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1079,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "1079",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["abiSpelltext"] = "Déchirure",
				["TimerLimit"] = 0,
				["abiAlert"] = false,
				["FX_timerposy"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_end_scale"] = 0.5,
				["FX_timersmall"] = true,
				["showdottimer"] = true,
				["ids"] = {
					1079, -- [1]
				},
				["FX_start_alpha"] = 0,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_middle_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_timerenable"] = false,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textoffsety"] = -40,
				["names"] = {
					"Déchirure", -- [1]
				},
				["FX_customtexture"] = "",
				["FX_middle_width"] = 1,
				["FX_textalign"] = "CENTER",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timeralpha"] = 0.35,
				["FX_start_scale"] = 0.5,
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["height"] = 32,
				["sType"] = "DebuffTarget",
				["showcd"] = true,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_timerabove"] = false,
				["luaCode"] = "local current = UnitHealth(\"target\")\nlocal maxi = UnitHealthMax(\"target\")\nif maxi>0 then\n  percent = current/maxi\n  if percent<=0.25 or maxi<50000 then\n    DF_namespace:icon_setTexture(DF_abiNum,\"Interface\\\\icons\\\\ability_druid_ferociousbite\")\n  else\n    DF_namespace:icon_setTexture(DF_abiNum,\"Interface\\\\icons\\\\ability_ghoulfrenzy\")\n  end\nelse\n  DF_namespace:icon_setTexture(DF_abiNum,\"Interface\\\\icons\\\\ability_ghoulfrenzy\")\nend\nreturn true",
				["FX_end_posx"] = 0,
				["timerbar"] = 0,
				["FX_start_posx"] = 0,
				["FX_pulsespeedZ"] = 0,
			}, -- [22]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1822,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "1822",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["abiSpelltext"] = "Griffure",
				["FX_pulsespeedZ"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_end_scale"] = 0.5,
				["FX_timersmall"] = true,
				["showdottimer"] = true,
				["ids"] = {
					1822, -- [1]
				},
				["FX_start_alpha"] = 0,
				["FX_customtexture"] = "",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["strongcheck"] = false,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_middle_scale"] = 1,
				["names"] = {
					"Griffure", -- [1]
				},
				["abiDuration"] = 0,
				["FX_middle_width"] = 1,
				["height"] = 32,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timeralpha"] = 0.35,
				["FX_textalign"] = "CENTER",
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_timerenable"] = false,
				["abiLast"] = 0,
				["abiEnd"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_middle_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_stack"] = 0,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_timerposy"] = 0,
			}, -- [23]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 62606,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 70,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["FX_positionx"] = 68,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 260,
				["FX_pulsepowerX"] = 1,
				["FX_end_width"] = 1,
				["FX_width"] = 250,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = true,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 1.5,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "62606",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 3.635999999998603,
				["FX_chakerpower"] = 0,
				["FX_timerposy"] = 0,
				["abiSpelltext"] = "Défense sauvage",
				["TimerLimit"] = 0,
				["timerbar"] = 0,
				["FX_middle_scale"] = 1.25,
				["FX_end_scale"] = 3,
				["ids"] = {
					62606, -- [1]
				},
				["FX_timersmall"] = false,
				["FX_customtexture"] = "",
				["FX_start_alpha"] = 0,
				["FX_middle_posx"] = 0,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_end_posx"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\custom\\bubble",
				["FX_pulsepowerZ"] = 0.3,
				["FX_start_scale"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -49,
				["abiEnd"] = 0,
				["names"] = {
					"Défense sauvage", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_textalign"] = "CENTER",
				["perso"] = true,
				["height"] = 32,
				["FX_timeralpha"] = 0.25,
				["abiLast"] = 0,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_timerenable"] = false,
				["abiDuration"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "HeartBeat",
				["showdottimer"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_pulsespeedZ"] = 10,
				["FX_start_posy"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 185,
			}, -- [24]
		},
		["anchor8"] = {
			["visible"] = true,
			["positiony"] = -128,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "DOTS",
			["positionx"] = 128,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["cursorspeed"] = 30,
		["healthbar"] = {
			["fontSize"] = 12,
			["positiony"] = 40,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["colorBad"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["colorDef"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["sformat"] = "#C k/#M k (#p%) #t",
			["colorAverage"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.5,
				["r"] = 1,
			},
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["colorchg"] = true,
			["textx"] = -7,
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["colorGood"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["width"] = 192,
			["textAlign"] = "RIGHT",
			["orientation"] = "HORIZONTAL",
			["showText"] = true,
			["texty"] = 1,
			["height"] = 18,
			["positionx"] = 8,
			["level"] = 2,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["ooc"] = {
			["spell"] = 12536,
			["positiony"] = 17,
			["scaleMin"] = 1,
			["mode"] = "ADD",
			["width"] = "650",
			["textureOff"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
			["positionx"] = 70,
			["scaleMax"] = 0.1,
			["textureOn"] = "Interface\\AddOns\\DroodFocus\\datas\\ooc.tga",
			["height"] = "150",
			["level"] = 10,
			["speed"] = 0.1,
			["enable"] = true,
		},
		["timerbars"] = {
			{
				["stack"] = {
					{
						["label"]="Active",
						["value"]=1,
					},
					{
						["label"]="Inactive",
						["value"]=0,
					},
					{
						["label"]="CD",
						["value"]=2,
					},
					{
						["label"]="Ready",
						["value"]=3,
					},
				},
				["orderByTime"] = false,
				["enable"] = true,
				["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["border"] = true,
				["prop"] = true,
				["borderSize"] = 1,
				["cdColor"] = {
					["a"] = 0.9400000013411045,
					["b"] = 0,
					["v"] = 1,
					["r"] = 1,
				},
				["showTimeLine"] = true,
				["activeAlphaCD"] = 0.6,
				["level"] = 4,
				["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
				["stackup1"] = true,
				["showSpark"] = true,
				["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
				["cdoffsetx"] = 0,
				["growup"] = false,
				["height"] = 18,
				["font1Size"] = 9,
				["width"] = 184,
				["borderColor"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 0,
				},
				["textsoffsets"] = {
					{
						["offsety"] = 1,
						["offsetx"] = 0,
					}, -- [1]
					{
						["offsety"] = 0,
						["offsetx"] = 2,
					}, -- [2]
				},
				["cdoffsety"] = 2,
				["timeline"] = 14,
				["font2Size"] = 16,
				["activeAlpha"] = 1,
				["inactiveAlpha"] = 1,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
			}, -- [1]
			{
				["stack"] = {
					{
						["label"]="Active",
						["value"]=1,
					},
					{
						["label"]="Inactive",
						["value"]=0,
					},
					{
						["label"]="CD",
						["value"]=2,
					},
					{
						["label"]="Ready",
						["value"]=3,
					},
				},
				["orderByTime"] = true,
				["enable"] = true,
				["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["border"] = true,
				["prop"] = true,
				["borderSize"] = 1,
				["cdColor"] = {
					["a"] = 0.9299999997019768,
					["b"] = 0,
					["v"] = 1,
					["r"] = 1,
				},
				["showTimeLine"] = true,
				["activeAlphaCD"] = 0.6,
				["level"] = 4,
				["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
				["stackup1"] = true,
				["showSpark"] = true,
				["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
				["cdoffsetx"] = 0,
				["growup"] = false,
				["height"] = 18,
				["font1Size"] = 9,
				["width"] = 184,
				["borderColor"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 0,
				},
				["textsoffsets"] = {
					{
						["offsety"] = 1,
						["offsetx"] = 0,
					}, -- [1]
					{
						["offsety"] = 0,
						["offsetx"] = 2,
					}, -- [2]
				},
				["cdoffsety"] = 2,
				["timeline"] = 14,
				["font2Size"] = 16,
				["activeAlpha"] = 1,
				["inactiveAlpha"] = 0,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
			}, -- [2]
		},
		["TimerLimit"] = 0,
		["iconbars"] = {
			{
				["stack"] = {
					{
						["label"]="Active",
						["value"]=1,
					},
					{
						["label"]="Inactive",
						["value"]=0,
					},
					{
						["label"]="CD",
						["value"]=2,
					},
					{
						["label"]="Ready",
						["value"]=3,
					},
				},
				["fontSize"] = 13,
				["orderByTime"] = true,
				["decimal"] = false,
				["enable"] = true,
				["spacex"] = 38,
				["activeAlpha"] = 1,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["spacey"] = 39,
				["speed"] = 4,
				["mode"] = "BLEND",
				["timerformat"] = false,
				["height2"] = 37,
				["height"] = 37,
				["inactiveCDAlpha"] = 0.3,
				["textsoffsets"] = {
					{
						["visible"] = true,
						["offsety"] = -2,
						["align"] = "TOPLEFT",
						["offsetx"] = 1,
						["size"] = 14,
					}, -- [1]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMRIGHT",
						["offsetx"] = 0,
						["size"] = 10,
					}, -- [2]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMLEFT",
						["offsetx"] = 2,
						["size"] = 10,
					}, -- [3]
				},
				["inactiveAlpha"] = 0.3,
				["growup"] = false,
				["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["pointpa"] = true,
				["width"] = 37,
				["pulse"] = 1.2,
				["showSpiral"] = 1,
				["colonne"] = 8,
				["automatic"] = true,
				["width2"] = 37,
				["level"] = 10,
				["pulsecd"] = false,
				["colonne2"] = 8,
			}, -- [1]
			{
				["stack"] = {
					{
						["label"]="Active",
						["value"]=1,
					},
					{
						["label"]="Inactive",
						["value"]=0,
					},
					{
						["label"]="CD",
						["value"]=2,
					},
					{
						["label"]="Ready",
						["value"]=3,
					},
				},
				["fontSize"] = 13,
				["orderByTime"] = true,
				["decimal"] = false,
				["enable"] = true,
				["spacex"] = 39,
				["activeAlpha"] = 1,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["spacey"] = 39,
				["pulsecd"] = false,
				["level"] = 10,
				["timerformat"] = false,
				["height2"] = 37,
				["height"] = 37,
				["inactiveCDAlpha"] = 0.5,
				["textsoffsets"] = {
					{
						["visible"] = true,
						["offsety"] = -2,
						["align"] = "TOP",
						["offsetx"] = 0,
						["size"] = 14,
					}, -- [1]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMRIGHT",
						["offsetx"] = 1,
						["size"] = 10,
					}, -- [2]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMLEFT",
						["offsetx"] = 1,
						["size"] = 10,
					}, -- [3]
				},
				["growup"] = false,
				["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["showSpiral"] = 1,
				["pointpa"] = true,
				["width"] = 37,
				["pulse"] = 1.6,
				["speed"] = 4,
				["colonne"] = 20,
				["automatic"] = true,
				["width2"] = 37,
				["mode"] = "BLEND",
				["inactiveAlpha"] = 1,
				["colonne2"] = 8,
			}, -- [2]
		},
		["eclipsebar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["textx"] = -7,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["texty"] = 1,
			["width"] = 192,
			["color2"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0.5,
				["b"] = 0,
			},
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 18,
			["positionx"] = 8,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0.5,
				["b"] = 1,
			},
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["alert"] = {
			["fontSize"] = 10,
			["positiony"] = 358,
			["decalx"] = 0,
			["decaly"] = 0,
			["enable"] = true,
			["textOffsetX"] = 0,
			["showDebuff"] = true,
			["level"] = 5,
			["texture3"] = "Interface\\AddOns\\DroodFocus\\datas\\alertSkull.tga",
			["texture2"] = "Interface\\AddOns\\DroodFocus\\datas\\alertRange.tga",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["width"] = 100,
			["alpha"] = 0.5,
			["showBuff"] = false,
			["texture1"] = "Interface\\AddOns\\DroodFocus\\datas\\alertBehind.tga",
			["persistence"] = 1.5,
			["showText"] = true,
			["textOffsetY"] = -36,
			["height"] = 100,
			["positionx"] = 616,
			["mode"] = "BLEND",
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["petbar"] = {
			["fontSize"] = 11,
			["positiony"] = -6,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.2,
				["r"] = 1,
			},
			["width"] = 192,
			["textx"] = -4,
			["positionx"] = 10,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 13,
			["texty"] = 0,
			["textAlign"] = "RIGHT",
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
	}, -- [9]
	{
		["configversion"] = 433,
		["MiniMapAngle"] = 215.8160744865155,
		["portrait"] = {
			["textures"] = {
				"Interface\\AddOns\\DroodFocus\\datas\\empty.tga", -- [1]
				"Interface\\AddOns\\DroodFocus\\datas\\bearform.tga", -- [2]
				"Interface\\AddOns\\DroodFocus\\datas\\aquaform.tga", -- [3]
				"Interface\\AddOns\\DroodFocus\\datas\\catform.tga", -- [4]
				"Interface\\AddOns\\DroodFocus\\datas\\travelform.tga", -- [5]
				"Interface\\AddOns\\DroodFocus\\datas\\moonkinform.tga", -- [6]
				"Interface\\AddOns\\DroodFocus\\datas\\flightform.tga", -- [7]
				"Interface\\AddOns\\DroodFocus\\datas\\treeform.tga", -- [8]
			},
			[true] = 100,
			["positiony"] = -7.499752877781191,
			["enable"] = true,
			["width"] = 52,
			["height"] = 52,
			["mode"] = "ADD",
			["level"] = 5,
			["positionx"] = 0,
		},
		["powerbar"] = {
			["fontSize"] = 17,
			["positiony"] = -18.5,
			["enable"] = true,
			["border"] = true,
			["borderSize"] = 1,
			["colorNrj"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 1,
			},
			["texty"] = -0.5,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["interval"] = 1,
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["colorDef"] = {
				["a"] = 1,
				["b"] = 0.5,
				["v"] = 0.5,
				["r"] = 0.5,
			},
			["sformat"] = "#c",
			["positionx"] = 10,
			["orientation"] = "HORIZONTAL",
			["enableArrows"] = true,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["colorRage"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["colorMana"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 0,
				["r"] = 0,
			},
			["arrows"] = {
				33876, -- [1]
				5221, -- [2]
				80, -- [3]
				1079, -- [4]
				-1, -- [5]
				-1, -- [6]
			},
			["width"] = 192,
			["showText"] = true,
			["textx"] = -4,
			["height"] = 32,
			["textAlign"] = "RIGHT",
			["showSpark"] = true,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["threatbar"] = {
			["fontSize"] = 8,
			["positiony"] = -63,
			["enable"] = true,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 3,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#c%",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["textx"] = -4,
			["width"] = 192,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 8,
			["texty"] = 0,
			["positionx"] = 10,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["gridSizeX"] = 1,
		["optionsScale"] = 0.85,
		["sound"] = {
			["enable"] = true,
			["soundfiles"] = {
				"", -- [1]
				"Sound\\Spells\\Druid_Pounce.wav", -- [2]
				"", -- [3]
				"Sound\\Spells\\Druid_FeralCharge.wav", -- [4]
				"", -- [5]
				"", -- [6]
				"", -- [7]
				"", -- [8]
			},
		},
		["timelines"] = {
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["enable"] = false,
			["activeAlpha"] = 0.1,
			["width"] = 1,
		},
		["activeForms"] = {
			false, -- [1]
			true, -- [2]
			false, -- [3]
			true, -- [4]
			false, -- [5]
			false, -- [6]
			false, -- [7]
			false, -- [8]
		},
		["anchor5"] = {
			["visible"] = true,
			["positiony"] = -263,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "INFOS",
			["positionx"] = 752,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor3"] = {
			["visible"] = true,
			["positiony"] = -102,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "TIMERBARS 1",
			["positionx"] = 244,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["icons"] = {
			["fontSize"] = 13,
			["orderByTime"] = true,
			["decimal"] = false,
			["automatic"] = true,
			["showSpiral"] = 1,
			["inactiveAlpha"] = 0.3,
			["level"] = 10,
			["height2"] = 37,
			["colonne2"] = 8,
			["textsoffsets"] = {
				{
					["visible"] = true,
					["offsety"] = -2,
					["align"] = "TOP",
					["offsetx"] = 0,
					["size"] = 14,
				}, -- [1]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMRIGHT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [2]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMLEFT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [3]
			},
			["mode"] = "BLEND",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["growup"] = false,
			["pointpa"] = true,
			["width"] = 37,
			["height"] = 37,
			["pulse"] = 1.6,
			["enable"] = true,
			["activeAlpha"] = 1,
			["width2"] = 37,
			["speed"] = 4,
			["colonne"] = 8,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["blood"] = {
			["persistence"] = 6,
			["level"] = 1,
			["NotInRaid"] = true,
			["enable"] = true,
			["mode"] = "BLEND",
			["alpha"] = 0.7,
			["size"] = 0.7,
		},
		["anchor4"] = {
			["visible"] = true,
			["positiony"] = 4,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "TIMERBARS 2",
			["positionx"] = 244,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["reportkickchan"] = "NONE",
		["anchor7"] = {
			["visible"] = true,
			["positiony"] = -145,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "ICONS 2",
			["positionx"] = 229,
			["height"] = 32,
			["level"] = 1,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["haveTarget"] = false,
		["alignToGrid"] = true,
		["inCombat"] = false,
		["configname"] = "[BuildIn] Default (HiRes)",
		["roundMethod"] = true,
		["combo"] = {
			["fontSize"] = 18,
			["positiony"] = 0,
			["enable"] = true,
			["textOffsetX"] = 12,
			["impulsion"] = 1.2,
			["level"] = 12,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\combo.tga",
			["textures"] = {
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_gray.tga", -- [1]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_yellow.tga", -- [2]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_gray.tga", -- [3]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_red.tga", -- [4]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga", -- [5]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_rune_blood.tga", -- [6]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga", -- [7]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_rune_frost.tga", -- [8]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga", -- [9]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_rune_unholy.tga", -- [10]
				[13] = "Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga",
				[14] = "Interface\\AddOns\\DroodFocus\\custom\\combo_holy.tga",
			},
			["angleA"] = 288,
			["offsety"] = 0,
			["ptype"] = 1,
			["angleB"] = 183,
			["form"] = {
				false, -- [1]
				true, -- [2]
				false, -- [3]
				true, -- [4]
				false, -- [5]
				false, -- [6]
				false, -- [7]
			},
			["mode"] = "BLEND",
			["width"] = 43,
			["offsetx"] = 38,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showText"] = false,
			["textOffsetY"] = -17,
			["height"] = 19,
			["positionx"] = 5,
			["rayon"] = 37,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["anchor0"] = {
			["visible"] = true,
			["positiony"] = 290,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "GLOBAL",
			["positionx"] = 607,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["cooldown"] = {
			["offsety"] = -48,
			["positiony"] = -1.000137314198355,
			["enable"] = true,
			["alpha"] = 0.7,
			["width"] = 49,
			["positionx"] = 199.9999970197678,
			["mode"] = "BLEND",
			["height"] = 49,
			["level"] = 5,
			["offsetx"] = 0,
			["temps"] = 3,
		},
		["anchor6"] = {
			["visible"] = true,
			["positiony"] = -52,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "CD",
			["level"] = 10,
			["height"] = 32,
			["positionx"] = 0,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["reportkick"] = true,
		["targetbar"] = {
			["fontSize"] = 9,
			["positiony"] = -50,
			["enable"] = true,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#M k (#p%) #t",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["textx"] = -4,
			["width"] = 192,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.75,
				["r"] = 1,
			},
			["positionx"] = 10,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 13,
			["texty"] = 0,
			["textAlign"] = "RIGHT",
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["infos"] = {
			["fontSize"] = 8,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["infolines"] = "PA: #meleeAP (#maxAP)*CC: #meleeCrit (#maxCrit%)*HASTE: #meleeHaste",
			["enable"] = false,
			["level"] = 12,
			["backColor"] = {
				["a"] = 0,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["textColor"] = {
				["a"] = 0.4600000381469727,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["minimap"] = true,
		["anchor2"] = {
			["visible"] = true,
			["positiony"] = 2,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "ICONS 1",
			["level"] = 1,
			["height"] = 32,
			["positionx"] = 51.5,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["fixrip"] = false,
		["uiAlwaysShow"] = false,
		["timerbar"] = {
			["activeAlpha"] = 1,
			["cdColor"] = {
				["a"] = 0.4900000095367432,
				["b"] = 0,
				["v"] = 1,
				["r"] = 1,
			},
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["inactiveAlpha"] = 0,
			["level"] = 4,
			["height2"] = "22",
			["prop2"] = true,
			["growup"] = false,
			["font1Size"] = 12,
			["timeline"] = 14,
			["cdoffsety"] = 2,
			["height"] = "22",
			["activeAlpha2"] = 1,
			["orderByTime"] = true,
			["enable"] = true,
			["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showSpark"] = true,
			["prop"] = true,
			["borderSize"] = 1,
			["activeAlphaCD"] = 1,
			["cdoffsetx"] = 0,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["textsoffsets"] = {
				{
					["offsety"] = 1,
					["offsetx"] = 0,
				}, -- [1]
				{
					["offsety"] = 0,
					["offsetx"] = 2,
				}, -- [2]
			},
			["activeAlphaCD2"] = 1,
			["stackup2"] = true,
			["width"] = "257.25",
			["inactiveAlpha2"] = 0,
			["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["stackup1"] = false,
			["font2Size"] = 20,
			["width2"] = "257.25",
			["showTimeLine"] = true,
			["border"] = true,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["gridSizeY"] = 1,
		["gps"] = {
			["fontSize"] = 10,
			["gpsTarget"] = {
				"target", -- [1]
				"focus", -- [2]
			},
			["positiony"] = 202.6987448411231,
			["enable"] = true,
			["offsety"] = -16,
			["alpha"] = 1,
			["width"] = 28,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["positionx"] = 0,
			["level"] = 10,
			["mode"] = "BLEND",
			["height"] = 28,
			["offsetx"] = 0,
			["positions"] = {
				{
					["y"] = 114.1027500492217,
					["x"] = 755.2753778377884,
				}, -- [1]
				{
					["y"] = 137.7306397605736,
					["x"] = 662.8310612926789,
				}, -- [2]
				{
				}, -- [3]
			},
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["anchor1"] = {
			["visible"] = true,
			["positiony"] = -36,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "UI",
			["mode"] = "BLEND",
			["height"] = 32,
			["level"] = 1,
			["positionx"] = 48,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["defensebar"] = {
			["fontSize"] = 9,
			["positiony"] = 95,
			["enable"] = true,
			["border"] = false,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar5.tga",
			["sformat"] = "#C k/#M k",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				false, -- [1]
				true, -- [2]
				false, -- [3]
				false, -- [4]
				false, -- [5]
				false, -- [6]
				false, -- [7]
				false, -- [8]
			},
			["color"] = {
				["a"] = 0.7900000065565109,
				["b"] = 0.9686274509803922,
				["v"] = 1,
				["r"] = 0.5372549019607843,
			},
			["width"] = 140,
			["textx"] = -4,
			["positionx"] = 33,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 16,
			["texty"] = 0,
			["textAlign"] = "CENTER",
			["textColor"] = {
				["a"] = 1,
				["b"] = 0.7803921568627451,
				["v"] = 0.7803921568627451,
				["r"] = 0.7803921568627451,
			},
		},
		["castbar"] = {
			["positiony"] = 77,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["activeAlpha"] = 1,
			["timerAlign"] = "RIGHT",
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["inactiveAlpha"] = 0,
			["level"] = 3,
			["timery"] = 0,
			["textx"] = 3,
			["sound1"] = "Interface\\AddOns\\DroodFocus\\datas\\DF_alert.ogg",
			["showText"] = true,
			["height"] = 24,
			["positionx"] = 10,
			["sound2"] = "",
			["fontSize"] = 12,
			["colori"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["enable"] = true,
			["timerx"] = -3,
			["borderSize"] = 2,
			["fontPathtimer"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["timerColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showTimer"] = true,
			["textAlign"] = "LEFT",
			["width"] = 192,
			["showSpark"] = true,
			["impulsion"] = 1,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["fontSizetimer"] = 16,
			["orientation"] = "HORIZONTAL",
			["texty"] = 0,
			["border"] = true,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["manabar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 0,
				["r"] = 0,
			},
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["enable"] = false,
			["width"] = 192,
			["textx"] = -7,
			["positionx"] = 8,
			["showText"] = true,
			["height"] = 18,
			["orientation"] = "HORIZONTAL",
			["texty"] = 1,
			["textAlign"] = "RIGHT",
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["spells"] = {
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 77758,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "77758",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["ids"] = {
					77758, -- [1]
				},
				["FX_textoffsetx"] = 0,
				["FX_timerposy"] = 0,
				["abiSpelltext"] = "Rosser",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_rotatespeed"] = 0,
				["FX_timersmall"] = true,
				["abiEnd"] = 0,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["FX_textalign"] = "CENTER",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["strongcheck"] = false,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_start_height"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_customtexture"] = "",
				["names"] = {
					"Rosser", -- [1]
				},
				["FX_timerenable"] = false,
				["abiFake"] = 0,
				["showdottimer"] = true,
				["FX_end_posx"] = 0,
				["FX_timeralpha"] = 0.35,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["comboPoints"] = 0,
				["height"] = 32,
				["abiRdyMode"] = false,
				["FX_middle_width"] = 1,
				["FX_end_scale"] = 0.5,
				["FX_start_scale"] = 0.5,
				["FX_textoffsety"] = -40,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_middle_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["abiLast"] = 0,
				["FX_start_posx"] = 0,
				["FX_start_posy"] = 0,
			}, -- [1]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 90166,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					90166, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "90166",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0.009999999998399289,
				["FX_chakerpower"] = 0,
				["FX_textenabled"] = false,
				["FX_textoffsetx"] = 0,
				["FX_middle_scale"] = 1,
				["FX_start_posy"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_textalign"] = "CENTER",
				["FX_timersmall"] = true,
				["FX_rotatespeed"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_name"] = "Custom",
				["showdottimer"] = true,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_middle_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_start_height"] = 1,
				["names"] = {
					"Force de la panthère", -- [1]
				},
				["FX_stack"] = 0,
				["abiFake"] = 0,
				["FX_end_posx"] = 0,
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["height"] = 32,
				["abiRdyMode"] = false,
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_end_scale"] = 0.5,
				["abiDuration"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["abiEnd"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["abiSpelltext"] = "Force de la panthère",
				["FX_start_posx"] = 0,
				["showcd"] = true,
			}, -- [2]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 92108,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 50,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = -23,
				["abiWarn"] = 6,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 2,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "92108;59520",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 45.40200000000004,
				["FX_chakerpower"] = 0,
				["FX_stack"] = 0,
				["TimerLimit"] = 0,
				["abiSpelltext"] = "Carnage insouciant",
				["FX_start_posy"] = 0,
				["sType"] = "BuffPlayer",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_end_posx"] = 0,
				["FX_timersmall"] = true,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_start_alpha"] = 0,
				["FX_middle_posx"] = 0,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_timerposy"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textalign"] = "CENTER",
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["height"] = 32,
				["names"] = {
					"Carnage insouciant", -- [1]
					"Rafale d'eau", -- [2]
				},
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_customtexture"] = "",
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_rotatespeed"] = 0,
				["comboPoints"] = 0,
				["FX_end_scale"] = 0.5,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["perso"] = true,
				["FX_textoffsety"] = -40,
				["FX_start_scale"] = 0.5,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["showcd"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_textoffsetx"] = 0,
				["ids"] = {
					92108, -- [1]
					59520, -- [2]
				},
				["FX_start_posx"] = 0,
				["FX_positiony"] = 177,
			}, -- [3]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 92104,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["FX_customtexture"] = "",
				["positionx"] = 64,
				["FX_positionx"] = -23,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 2,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "92104",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 2.401000000001659,
				["FX_chakerpower"] = 0,
				["FX_middle_scale"] = 1,
				["FX_timerscale"] = 0.4,
				["abiSpelltext"] = "Rivière de la mort",
				["FX_start_posy"] = 0,
				["ids"] = {
					92104, -- [1]
				},
				["FX_end_scale"] = 0.5,
				["sType"] = "BuffPlayer",
				["FX_timersmall"] = true,
				["showcd"] = true,
				["FX_name"] = "Custom",
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 0.6078431372549019,
					["b"] = 1,
				},
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["abiEnd"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_end_posx"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["names"] = {
					"Rivière de la mort", -- [1]
				},
				["abiFake"] = 0,
				["perso"] = true,
				["abiDuration"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_timeralpha"] = 0.35,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["comboPoints"] = 0,
				["FX_stack"] = 0,
				["abiRdyMode"] = false,
				["FX_middle_width"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["combo"] = false,
				["FX_mode"] = "BLEND",
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["showdottimer"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_textoffsetx"] = 0,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 177,
			}, -- [4]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 69369,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 2,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "69369",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 7.505999999997584,
				["FX_chakerpower"] = 0,
				["FX_middle_scale"] = 1,
				["TimerLimit"] = 0,
				["abiEnd"] = 0,
				["FX_customtexture"] = "",
				["FX_rotatespeed"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_textoffsetx"] = 0,
				["FX_timersmall"] = true,
				["FX_textalign"] = "CENTER",
				["FX_start_alpha"] = 0,
				["FX_start_height"] = 1,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["showcd"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_stack"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["names"] = {
					"Rapidité du prédateur", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_mode"] = "BLEND",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["ids"] = {
					69369, -- [1]
				},
				["FX_timeralpha"] = 0.35,
				["showdottimer"] = true,
				["comboPoints"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0.07450980392156863,
					["v"] = 1,
					["r"] = 0,
				},
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_middle_posx"] = 0,
				["combo"] = false,
				["abiDuration"] = 0,
				["form"] = {
					true, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_end_scale"] = 0.5,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["abiSpelltext"] = "Rapidité du prédateur",
				["FX_start_posy"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [5]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 50334,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 50,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["FX_positionx"] = 134,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 100,
				["abiSpelltext"] = "Berserk",
				["FX_end_width"] = 1,
				["FX_width"] = 100,
				["FX_stack"] = 0,
				["FX_pulsespeedZ"] = 13.5,
				["FX_textenabled"] = true,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.55,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "50334",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 185.7220000000016,
				["FX_chakerpower"] = 1.75,
				["FX_start_posy"] = 0,
				["FX_rotatespeed"] = 0,
				["ids"] = {
					50334, -- [1]
				},
				["TimerLimit"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_end_scale"] = 0,
				["FX_textalign"] = "CENTER",
				["FX_timersmall"] = false,
				["FX_middle_posx"] = 0,
				["FX_name"] = "HeartBeat",
				["height"] = 32,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["abiEnd"] = 0,
				["FX_pulsepowerZ"] = 0.5,
				["FX_start_scale"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -36,
				["perso"] = true,
				["names"] = {
					"Berserk", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\custom\\lion",
				["FX_end_posx"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_timeralpha"] = 0.25,
				["FX_timerenable"] = false,
				["comboPoints"] = 0,
				["abiDuration"] = 0,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["abiLast"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_pulsepowerX"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_customtexture"] = "",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["timerbar"] = 1,
				["FX_middle_scale"] = 0.8,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 176,
			}, -- [6]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 5217,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 50,
				["FX_customtexture"] = "",
				["positionx"] = 64,
				["FX_positionx"] = 1,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 100,
				["FX_stack"] = 0,
				["FX_pulsespeedZ"] = 13.5,
				["FX_textenabled"] = true,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.55,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "5217",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 27.08099999999831,
				["FX_chakerpower"] = 1.75,
				["FX_textalign"] = "CENTER",
				["FX_rotatespeed"] = 0,
				["abiAlert"] = false,
				["FX_middle_scale"] = 0.8,
				["FX_middle_posx"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\custom\\paw",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timersmall"] = false,
				["FX_textoffsetx"] = 0,
				["FX_name"] = "Custom",
				["height"] = 32,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["showcd"] = true,
				["FX_pulsepowerZ"] = 0.5,
				["FX_start_scale"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -36,
				["FX_end_posx"] = 0,
				["names"] = {
					"Fureur du tigre", -- [1]
				},
				["abiFake"] = 0,
				["FX_timerenable"] = false,
				["sType"] = "BuffPlayer",
				["abiSpelltext"] = "Fureur du tigre",
				["FX_timeralpha"] = 0.25,
				["abiEnd"] = 0,
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = true,
				["FX_middle_width"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["abiDuration"] = 0,
				["timerbar"] = 1,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_end_scale"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_height"] = 100,
				["ids"] = {
					5217, -- [1]
				},
				["FX_start_posx"] = 0,
				["FX_positiony"] = 176,
			}, -- [7]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 82365,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 1,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "82365",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_stack"] = 0,
				["FX_start_posy"] = 0,
				["FX_height"] = 128,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_pulsespeedZ"] = 0,
				["FX_timersmall"] = true,
				["FX_timerposy"] = 0,
				["FX_start_alpha"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 0.6862745098039216,
					["r"] = 0,
				},
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["ids"] = {
					82365, -- [1]
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_end_scale"] = 0.5,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["sType"] = "DebuffTarget",
				["names"] = {
					"Coup de crâne", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_start_height"] = 1,
				["FX_customtexture"] = "",
				["abiDuration"] = 0,
				["FX_timeralpha"] = 0.35,
				["FX_timerscale"] = 0.4,
				["comboPoints"] = 0,
				["FX_textoffsety"] = -40,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["FX_end_posx"] = 0,
				["combo"] = false,
				["height"] = 32,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["showcd"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_posx"] = 0,
				["abiSpelltext"] = "Coup de crâne",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [8]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 80951,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					80951, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "80951",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["abiSpelltext"] = "Pulvérisation",
				["timerbar"] = 0,
				["FX_start_posy"] = 0,
				["FX_pulsespeedZ"] = 0,
				["sType"] = "BuffPlayer",
				["FX_end_scale"] = 0.5,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timersmall"] = true,
				["FX_textenabled"] = false,
				["FX_start_alpha"] = 0,
				["abiLast"] = 0,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["showdottimer"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_rotatespeed"] = 0,
				["names"] = {
					"Pulvérisation", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_middle_posx"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_textoffsety"] = -40,
				["FX_mode"] = "BLEND",
				["FX_textalign"] = "CENTER",
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_scale"] = 1,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [9]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 5229,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["FX_customtexture"] = "",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Enrager",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "5229",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_start_posy"] = 0,
				["timerbar"] = 1,
				["FX_pulsespeedZ"] = 0,
				["TimerLimit"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 0.6862745098039216,
					["r"] = 0,
				},
				["FX_end_scale"] = 0.5,
				["abiEnd"] = 0,
				["FX_timersmall"] = true,
				["FX_pulsepowerX"] = 0,
				["FX_start_alpha"] = 0,
				["showdottimer"] = true,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_timerposy"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_mode"] = "BLEND",
				["names"] = {
					"Enrager", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_rotatespeed"] = 0,
				["combo"] = false,
				["perso"] = true,
				["FX_timeralpha"] = 0.35,
				["FX_start_scale"] = 0.5,
				["comboPoints"] = 0,
				["FX_textoffsety"] = -40,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiLast"] = 0,
				["FX_timerscale"] = 0.4,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_middle_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["sType"] = "BuffPlayer",
				["ids"] = {
					5229, -- [1]
				},
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [10]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 22812,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Ecorce",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "22812",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 72.80299999999988,
				["FX_chakerpower"] = 0,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					22812, -- [1]
				},
				["FX_start_posy"] = 0,
				["TimerLimit"] = 0,
				["abiLast"] = 0,
				["FX_end_scale"] = 0.5,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timersmall"] = true,
				["timerbar"] = 1,
				["FX_start_alpha"] = 0,
				["FX_pulsepowerX"] = 0,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0.07450980392156863,
					["v"] = 1,
					["r"] = 0,
				},
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_timerposy"] = 0,
				["names"] = {
					"Ecorce", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_start_scale"] = 0.5,
				["FX_rotatespeed"] = 0,
				["FX_mode"] = "BLEND",
				["FX_timeralpha"] = 0.35,
				["combo"] = false,
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["FX_customtexture"] = "",
				["FX_textoffsety"] = -40,
				["FX_middle_posx"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_end_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["sType"] = "BuffPlayer",
				["FX_textalign"] = "CENTER",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [11]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 91565,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Feu féerique",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "91565;7386;8647;35387;50498;770",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_timerscale"] = 0.4,
				["ids"] = {
					91565, -- [1]
					7386, -- [2]
					8647, -- [3]
					35387, -- [4]
					50498, -- [5]
					770, -- [6]
				},
				["FX_start_posy"] = 0,
				["showcd"] = true,
				["timerbar"] = 2,
				["FX_end_scale"] = 0.5,
				["FX_middle_scale"] = 1,
				["FX_timersmall"] = true,
				["FX_rotatespeed"] = 0,
				["FX_start_alpha"] = 0,
				["height"] = 32,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["showdottimer"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_customtexture"] = "",
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["names"] = {
					"Feu féerique", -- [1]
					"Fracasser armure", -- [2]
					"Exposer l'armure", -- [3]
					"Crachat corrosif", -- [4]
					"Déchirer armure", -- [5]
					"Lucioles", -- [6]
				},
				["FX_middle_width"] = 1,
				["FX_pulsespeedZ"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_textoffsety"] = -40,
				["FX_timeralpha"] = 0.35,
				["abiEnd"] = 0,
				["comboPoints"] = 0,
				["abiDuration"] = 0,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["perso"] = true,
				["FX_timerenable"] = false,
				["FX_end_posx"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_pulsepowerX"] = 0,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [12]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 16,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 61336,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 0.5,
				["abiInternalCD"] = 0,
				["FX_speed"] = 60,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 69,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Instincts de survie",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = true,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "61336",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 2,
				["FX_timerscale"] = 0.55,
				["ids"] = {
					61336, -- [1]
				},
				["TimerLimit"] = 0,
				["FX_start_posy"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_end_scale"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx_glow7.tga",
				["FX_timersmall"] = false,
				["FX_middle_scale"] = 3,
				["FX_start_alpha"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["showdottimer"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_customtexture"] = "",
				["FX_pulsepowerZ"] = 0.2,
				["FX_start_scale"] = 1,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 1,
					["b"] = 0.07450980392156863,
				},
				["names"] = {
					"Instincts de survie", -- [1]
				},
				["FX_middle_width"] = 1,
				["perso"] = true,
				["combo"] = false,
				["abiDuration"] = 0,
				["FX_timeralpha"] = 0.25,
				["timerbar"] = 1,
				["comboPoints"] = 0,
				["FX_textoffsety"] = -47.5,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["height"] = 32,
				["FX_pulsespeedZ"] = 0,
				["FX_end_posx"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Explode",
				["abiLast"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["sType"] = "BuffPlayer",
				["FX_pulsepowerX"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 188,
			}, -- [13]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 81022,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 20,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 70,
				["abiWarn"] = 0,
				["FX_angle"] = 19,
				["FX_height"] = 110,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 0.2,
				["FX_width"] = 110,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = true,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "81022",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiLast"] = 0,
				["FX_start_width"] = 0.2,
				["abiCD"] = 0,
				["abiLastCd"] = 28.1309999999994,
				["FX_chakerpower"] = 1,
				["FX_middle_scale"] = 1,
				["TimerLimit"] = 0,
				["FX_customtexture"] = "",
				["FX_start_posy"] = 0,
				["FX_pulsespeedZ"] = 16,
				["FX_end_scale"] = 1,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timersmall"] = false,
				["ids"] = {
					81022, -- [1]
				},
				["FX_name"] = "FromRight",
				["showcd"] = true,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["sType"] = "BuffPlayer",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_timerscale"] = 0.85,
				["FX_pulsepowerZ"] = 0.2,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_middle_posx"] = 0,
				["names"] = {
					"Ruée", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_start_height"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\custom\\tiger",
				["abiDuration"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_timerposy"] = 0,
				["comboPoints"] = 0,
				["FX_textoffsety"] = -18,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_mode"] = "BLEND",
				["FX_timerenable"] = false,
				["timerbar"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_end_posx"] = -160,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["showdottimer"] = true,
				["abiSpelltext"] = "Ruée",
				["FX_start_posx"] = 160,
				["FX_positiony"] = 243,
			}, -- [14]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 16870,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 128,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["FX_positionx"] = 72,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["abiSpelltext"] = "Idées claires",
				["FX_end_width"] = 1,
				["FX_width"] = 425,
				["FX_stack"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					16870, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "16870",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0.771999999999025,
				["FX_chakerpower"] = 1,
				["FX_start_posy"] = 0,
				["FX_height"] = 96,
				["FX_middle_scale"] = 1.75,
				["FX_pulsepowerX"] = 0,
				["FX_customtexture"] = "",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx_ooc.tga",
				["FX_middle_posx"] = 0,
				["FX_timersmall"] = true,
				["FX_textenabled"] = false,
				["FX_name"] = "Custom",
				["FX_start_height"] = 1,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_end_scale"] = 3,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textalign"] = "CENTER",
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["showdottimer"] = true,
				["names"] = {
					"Idées claires", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_mode"] = "ADD",
				["combo"] = false,
				["abiEnd"] = 0,
				["FX_timeralpha"] = 0.35,
				["abiLast"] = 0,
				["comboPoints"] = 0,
				["FX_start_scale"] = 0,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_textoffsety"] = -40,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["timerbar"] = 0,
				["form"] = {
					true, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					true, -- [6]
					false, -- [7]
					true, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_textoffsetx"] = 0,
				["FX_rotatespeed"] = 0.5,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 77,
			}, -- [15]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 33745,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["FX_customtexture"] = "",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					33745, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "33745",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_middle_scale"] = 1,
				["FX_textoffsetx"] = 0,
				["FX_start_posy"] = 0,
				["FX_height"] = 128,
				["abiLast"] = 0,
				["FX_end_scale"] = 0.5,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = true,
				["abiEnd"] = 0,
				["FX_name"] = "Custom",
				["showdottimer"] = true,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_textenabled"] = false,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_end_posx"] = 0,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = true,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_textalign"] = "CENTER",
				["names"] = {
					"Lacérer", -- [1]
				},
				["FX_middle_width"] = 1,
				["perso"] = true,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_stack"] = 0,
				["comboPoints"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_mode"] = "BLEND",
				["FX_start_scale"] = 0.5,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["sType"] = "DebuffTarget",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_rotatespeed"] = 0,
				["abiSpelltext"] = "Lacérer",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [16]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 33878,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Mutilation",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "33878;33876;46857;50271;35290;16511",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_pulsepowerX"] = 0,
				["TimerLimit"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_start_posy"] = 0,
				["abiEnd"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["showcd"] = true,
				["FX_timersmall"] = true,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["FX_rotatespeed"] = 0,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_end_scale"] = 0.5,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_customtexture"] = "",
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_timerscale"] = 0.4,
				["names"] = {
					"Mutilation", -- [1]
					"Mutilation", -- [2]
					"Traumatisme", -- [3]
					"Déchirure du tendon", -- [4]
					"Encorner", -- [5]
					"Hémorragie", -- [6]
				},
				["FX_middle_width"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_mode"] = "BLEND",
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["perso"] = false,
				["comboPoints"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiDuration"] = 0,
				["FX_end_posx"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 26,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["showdottimer"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["ids"] = {
					33878, -- [1]
					33876, -- [2]
					46857, -- [3]
					50271, -- [4]
					35290, -- [5]
					16511, -- [6]
				},
				["FX_middle_scale"] = 1,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [17]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 22842,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Régénération frénétique",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 1,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "22842",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_start_posy"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_pulsepowerX"] = 0,
				["sType"] = "BuffPlayer",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["showcd"] = true,
				["FX_timersmall"] = true,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["ids"] = {
					22842, -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_middle_scale"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_start_scale"] = 0.5,
				["names"] = {
					"Régénération frénétique", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_end_scale"] = 0.5,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textalign"] = "CENTER",
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["FX_mode"] = "BLEND",
				["combo"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 1,
					["b"] = 0.07450980392156863,
				},
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_end_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_posx"] = 0,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [18]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1850,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = -23,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Célérité",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 1,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "1850",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["FX_pulsepowerX"] = 0,
				["sType"] = "BuffPlayer",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_end_posx"] = 0,
				["FX_timersmall"] = true,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["FX_middle_scale"] = 1,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_customtexture"] = "",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["combo"] = false,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["names"] = {
					"Célérité", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_mode"] = "BLEND",
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["v"] = 1,
					["b"] = 0.07450980392156863,
				},
				["perso"] = true,
				["FX_timeralpha"] = 0.35,
				["FX_end_scale"] = 0.5,
				["comboPoints"] = 0,
				["FX_textalign"] = "CENTER",
				["abiRdyMode"] = true,
				["abiFake"] = 0,
				["abiDuration"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["showcd"] = true,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["ids"] = {
					1850, -- [1]
				},
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 177,
			}, -- [19]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 52610,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "52610",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 22.40299999999843,
				["FX_chakerpower"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_start_posy"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_end_posx"] = 0,
				["sType"] = "BuffPlayer",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["showcd"] = true,
				["FX_timersmall"] = true,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["ids"] = {
					52610, -- [1]
				},
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_middle_scale"] = 1,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_start_scale"] = 0.5,
				["names"] = {
					"Rugissement sauvage", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_end_scale"] = 0.5,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textalign"] = "CENTER",
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["FX_start_height"] = 1,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["height"] = 32,
				["combo"] = false,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["showdottimer"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["abiSpelltext"] = "Rugissement sauvage",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [20]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 99,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Rugissement démoralisant",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					99, -- [1]
					1160, -- [2]
					702, -- [3]
					26017, -- [4]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "99;1160;702;26017",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_start_posy"] = 0,
				["TimerLimit"] = 0,
				["sType"] = "DebuffTarget",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_textalign"] = "CENTER",
				["FX_timersmall"] = true,
				["FX_stack"] = 0,
				["FX_start_alpha"] = 0,
				["FX_end_posx"] = 0,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_end_scale"] = 0.5,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["combo"] = false,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textenabled"] = false,
				["names"] = {
					"Rugissement démoralisant", -- [1]
					"Cri démoralisant", -- [2]
					"Malédiction de faiblesse", -- [3]
					"Justification", -- [4]
				},
				["FX_middle_width"] = 1,
				["perso"] = true,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["showcd"] = true,
				["FX_timeralpha"] = 0.35,
				["FX_middle_posx"] = 0,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_textoffsety"] = -40,
				["height"] = 32,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_customtexture"] = "",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_scale"] = 1,
				["FX_pulsepowerX"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [21]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1079,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "1079",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["abiSpelltext"] = "Déchirure",
				["TimerLimit"] = 0,
				["abiAlert"] = false,
				["FX_timerposy"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_end_scale"] = 0.5,
				["FX_timersmall"] = true,
				["showdottimer"] = true,
				["ids"] = {
					1079, -- [1]
				},
				["FX_start_alpha"] = 0,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_middle_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_timerenable"] = false,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textoffsety"] = -40,
				["names"] = {
					"Déchirure", -- [1]
				},
				["FX_customtexture"] = "",
				["FX_middle_width"] = 1,
				["FX_textalign"] = "CENTER",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timeralpha"] = 0.35,
				["FX_start_scale"] = 0.5,
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["height"] = 32,
				["sType"] = "DebuffTarget",
				["showcd"] = true,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_timerabove"] = false,
				["luaCode"] = "local current = UnitHealth(\"target\")\nlocal maxi = UnitHealthMax(\"target\")\nif maxi>0 then\n  percent = current/maxi\n  if percent<=0.25 or maxi<50000 then\n    DF_namespace:icon_setTexture(DF_abiNum,\"Interface\\\\icons\\\\ability_druid_ferociousbite\")\n  else\n    DF_namespace:icon_setTexture(DF_abiNum,\"Interface\\\\icons\\\\ability_ghoulfrenzy\")\n  end\nelse\n  DF_namespace:icon_setTexture(DF_abiNum,\"Interface\\\\icons\\\\ability_ghoulfrenzy\")\nend\nreturn true",
				["FX_end_posx"] = 0,
				["timerbar"] = 0,
				["FX_start_posx"] = 0,
				["FX_textoffsetx"] = 0,
			}, -- [22]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1822,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "1822",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["abiSpelltext"] = "Griffure",
				["FX_timerposy"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_end_scale"] = 0.5,
				["FX_timersmall"] = true,
				["showdottimer"] = true,
				["ids"] = {
					1822, -- [1]
				},
				["FX_start_alpha"] = 0,
				["FX_customtexture"] = "",
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["strongcheck"] = false,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_middle_scale"] = 1,
				["names"] = {
					"Griffure", -- [1]
				},
				["abiDuration"] = 0,
				["FX_middle_width"] = 1,
				["height"] = 32,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timeralpha"] = 0.35,
				["FX_textalign"] = "CENTER",
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_timerenable"] = false,
				["abiLast"] = 0,
				["abiEnd"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_middle_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_stack"] = 0,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_textoffsetx"] = 0,
			}, -- [23]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 62606,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 70,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["FX_positionx"] = 68,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 200,
				["FX_pulsepowerX"] = 1,
				["FX_end_width"] = 1,
				["FX_width"] = 200,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = true,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 1.5,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "62606",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 3.635999999998603,
				["FX_chakerpower"] = 0,
				["FX_timerposy"] = 0,
				["abiSpelltext"] = "Défense sauvage",
				["TimerLimit"] = 0,
				["timerbar"] = 0,
				["FX_middle_scale"] = 1.25,
				["FX_end_scale"] = 3,
				["ids"] = {
					62606, -- [1]
				},
				["FX_timersmall"] = false,
				["FX_customtexture"] = "",
				["FX_start_alpha"] = 0,
				["FX_middle_posx"] = 0,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_end_posx"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\custom\\bubble",
				["FX_pulsepowerZ"] = 0.3,
				["FX_start_scale"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -35,
				["abiEnd"] = 0,
				["names"] = {
					"Défense sauvage", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_textalign"] = "CENTER",
				["perso"] = true,
				["height"] = 32,
				["FX_timeralpha"] = 0.25,
				["abiLast"] = 0,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_timerenable"] = false,
				["abiDuration"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "HeartBeat",
				["showdottimer"] = true,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_pulsespeedZ"] = 10,
				["FX_start_posy"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 166,
			}, -- [24]
		},
		["anchor8"] = {
			["visible"] = true,
			["positiony"] = -128,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "DOTS",
			["positionx"] = 128,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["cursorspeed"] = 30,
		["healthbar"] = {
			["fontSize"] = 12,
			["positiony"] = 40,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["colorBad"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["colorDef"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["sformat"] = "#C k/#M k (#p%) #t",
			["colorAverage"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.5,
				["r"] = 1,
			},
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["colorchg"] = true,
			["textx"] = -7,
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["colorGood"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["width"] = 192,
			["textAlign"] = "RIGHT",
			["orientation"] = "HORIZONTAL",
			["showText"] = true,
			["texty"] = 1,
			["height"] = 18,
			["positionx"] = 8,
			["level"] = 2,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["ooc"] = {
			["spell"] = 12536,
			["positiony"] = 17,
			["scaleMin"] = 1,
			["mode"] = "ADD",
			["width"] = "650",
			["textureOff"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
			["positionx"] = 70,
			["scaleMax"] = 0.1,
			["textureOn"] = "Interface\\AddOns\\DroodFocus\\datas\\ooc.tga",
			["height"] = "150",
			["level"] = 10,
			["speed"] = 0.1,
			["enable"] = true,
		},
		["timerbars"] = {
			{
				["orderByTime"] = false,
				["enable"] = true,
				["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["border"] = true,
				["prop"] = true,
				["borderSize"] = 1,
				["cdColor"] = {
					["a"] = 0.9400000013411045,
					["b"] = 0,
					["v"] = 1,
					["r"] = 1,
				},
				["showTimeLine"] = true,
				["activeAlphaCD"] = 0.6,
				["level"] = 4,
				["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
				["stackup1"] = true,
				["showSpark"] = true,
				["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
				["cdoffsetx"] = 0,
				["growup"] = false,
				["height"] = 17,
				["font1Size"] = 9,
				["width"] = 184,
				["borderColor"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 0,
				},
				["textsoffsets"] = {
					{
						["offsety"] = 1,
						["offsetx"] = 0,
					}, -- [1]
					{
						["offsety"] = 0,
						["offsetx"] = 2,
					}, -- [2]
				},
				["cdoffsety"] = 2,
				["timeline"] = 14,
				["font2Size"] = 16,
				["activeAlpha"] = 1,
				["inactiveAlpha"] = 1,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
			}, -- [1]
			{
				["orderByTime"] = true,
				["enable"] = true,
				["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["border"] = true,
				["prop"] = true,
				["borderSize"] = 1,
				["cdColor"] = {
					["a"] = 0.9299999997019768,
					["b"] = 0,
					["v"] = 1,
					["r"] = 1,
				},
				["showTimeLine"] = true,
				["activeAlphaCD"] = 0.6,
				["level"] = 4,
				["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
				["stackup1"] = true,
				["showSpark"] = true,
				["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
				["cdoffsetx"] = 0,
				["growup"] = false,
				["height"] = 17,
				["font1Size"] = 9,
				["width"] = 184,
				["borderColor"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 0,
				},
				["textsoffsets"] = {
					{
						["offsety"] = 1,
						["offsetx"] = 0,
					}, -- [1]
					{
						["offsety"] = 0,
						["offsetx"] = 2,
					}, -- [2]
				},
				["cdoffsety"] = 2,
				["timeline"] = 14,
				["font2Size"] = 16,
				["activeAlpha"] = 1,
				["inactiveAlpha"] = 0,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
			}, -- [2]
		},
		["TimerLimit"] = 0,
		["iconbars"] = {
			{
				["fontSize"] = 13,
				["orderByTime"] = true,
				["decimal"] = false,
				["enable"] = true,
				["spacex"] = 38,
				["activeAlpha"] = 1,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["spacey"] = 39,
				["speed"] = 4,
				["mode"] = "BLEND",
				["timerformat"] = false,
				["height2"] = 37,
				["height"] = 37,
				["inactiveCDAlpha"] = 0.3,
				["textsoffsets"] = {
					{
						["visible"] = true,
						["offsety"] = -2,
						["align"] = "TOPLEFT",
						["offsetx"] = 1,
						["size"] = 14,
					}, -- [1]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMRIGHT",
						["offsetx"] = 0,
						["size"] = 10,
					}, -- [2]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMLEFT",
						["offsetx"] = 2,
						["size"] = 10,
					}, -- [3]
				},
				["inactiveAlpha"] = 0.3,
				["growup"] = false,
				["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["pointpa"] = true,
				["width"] = 37,
				["pulse"] = 1.2,
				["showSpiral"] = 1,
				["colonne"] = 8,
				["automatic"] = true,
				["width2"] = 37,
				["level"] = 10,
				["pulsecd"] = false,
				["colonne2"] = 8,
			}, -- [1]
			{
				["fontSize"] = 13,
				["orderByTime"] = true,
				["decimal"] = false,
				["enable"] = true,
				["spacex"] = 39,
				["activeAlpha"] = 1,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["spacey"] = 39,
				["pulsecd"] = false,
				["level"] = 10,
				["timerformat"] = false,
				["height2"] = 37,
				["height"] = 37,
				["inactiveCDAlpha"] = 0.5,
				["textsoffsets"] = {
					{
						["visible"] = true,
						["offsety"] = -2,
						["align"] = "TOP",
						["offsetx"] = 0,
						["size"] = 14,
					}, -- [1]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMRIGHT",
						["offsetx"] = 1,
						["size"] = 10,
					}, -- [2]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMLEFT",
						["offsetx"] = 1,
						["size"] = 10,
					}, -- [3]
				},
				["growup"] = false,
				["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["showSpiral"] = 1,
				["pointpa"] = true,
				["width"] = 37,
				["pulse"] = 1.6,
				["speed"] = 4,
				["colonne"] = 20,
				["automatic"] = true,
				["width2"] = 37,
				["mode"] = "BLEND",
				["inactiveAlpha"] = 1,
				["colonne2"] = 8,
			}, -- [2]
		},
		["eclipsebar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["textx"] = -7,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["texty"] = 1,
			["width"] = 192,
			["color2"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0.5,
				["b"] = 0,
			},
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 18,
			["positionx"] = 8,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0.5,
				["b"] = 1,
			},
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["alert"] = {
			["fontSize"] = 10,
			["positiony"] = 426,
			["enable"] = true,
			["textOffsetX"] = 0,
			["showDebuff"] = true,
			["level"] = 5,
			["texture3"] = "Interface\\AddOns\\DroodFocus\\datas\\alertSkull.tga",
			["texture2"] = "Interface\\AddOns\\DroodFocus\\datas\\alertRange.tga",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["width"] = 100,
			["alpha"] = 0.5,
			["showBuff"] = false,
			["texture1"] = "Interface\\AddOns\\DroodFocus\\datas\\alertBehind.tga",
			["persistence"] = 1.5,
			["showText"] = true,
			["textOffsetY"] = -36,
			["height"] = 100,
			["positionx"] = 611,
			["mode"] = "BLEND",
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["petbar"] = {
			["fontSize"] = 11,
			["positiony"] = -6,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.2,
				["r"] = 1,
			},
			["width"] = 192,
			["textx"] = -4,
			["positionx"] = 10,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 13,
			["texty"] = 0,
			["textAlign"] = "RIGHT",
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
	}, -- [10]
	{
		["fixrip"] = false,
		["MiniMapAngle"] = 215.8160744865155,
		["portrait"] = {
			["textures"] = {
				"Interface\\AddOns\\DroodFocus\\datas\\empty.tga", -- [1]
				"Interface\\AddOns\\DroodFocus\\datas\\bearform.tga", -- [2]
				"Interface\\AddOns\\DroodFocus\\datas\\aquaform.tga", -- [3]
				"Interface\\AddOns\\DroodFocus\\datas\\catform.tga", -- [4]
				"Interface\\AddOns\\DroodFocus\\datas\\travelform.tga", -- [5]
				"Interface\\AddOns\\DroodFocus\\datas\\moonkinform.tga", -- [6]
				"Interface\\AddOns\\DroodFocus\\datas\\flightform.tga", -- [7]
				"Interface\\AddOns\\DroodFocus\\datas\\treeform.tga", -- [8]
			},
			[true] = 100,
			["positiony"] = -7.499752877781191,
			["enable"] = false,
			["width"] = 52,
			["height"] = 52,
			["mode"] = "ADD",
			["level"] = 5,
			["positionx"] = 0,
		},
		["powerbar"] = {
			["fontSize"] = 14,
			["positiony"] = -18.5,
			["enable"] = true,
			["showSpark"] = true,
			["borderSize"] = 1,
			["colorNrj"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 1,
			},
			["texty"] = -0.5,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["interval"] = 1,
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["colorDef"] = {
				["a"] = 1,
				["b"] = 0.5,
				["v"] = 0.5,
				["r"] = 0.5,
			},
			["sformat"] = "#c",
			["positionx"] = 10,
			["orientation"] = "HORIZONTAL",
			["enableArrows"] = true,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["colorRage"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["colorMana"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 0,
				["r"] = 0,
			},
			["arrows"] = {
				33876, -- [1]
				5221, -- [2]
				80, -- [3]
				1079, -- [4]
				-1, -- [5]
				-1, -- [6]
			},
			["width"] = 192,
			["showText"] = true,
			["textx"] = -4,
			["height"] = 23,
			["textAlign"] = "RIGHT",
			["border"] = true,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["threatbar"] = {
			["fontSize"] = 8,
			["positiony"] = -63,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 3,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#c%",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["textx"] = -4,
			["width"] = 192,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 8,
			["positionx"] = 10,
			["texty"] = 0,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["gridSizeX"] = 1,
		["optionsScale"] = 0.85,
		["sound"] = {
			["enable"] = true,
			["soundfiles"] = {
				"", -- [1]
				"Sound\\Spells\\Druid_Pounce.wav", -- [2]
				"", -- [3]
				"Sound\\Spells\\Druid_FeralCharge.wav", -- [4]
				"", -- [5]
				"", -- [6]
				"", -- [7]
				"", -- [8]
			},
		},
		["timelines"] = {
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["enable"] = false,
			["activeAlpha"] = 0.1,
			["width"] = 1,
		},
		["activeForms"] = {
			false, -- [1]
			true, -- [2]
			false, -- [3]
			true, -- [4]
			false, -- [5]
			false, -- [6]
			false, -- [7]
			false, -- [8]
		},
		["anchor5"] = {
			["visible"] = true,
			["positiony"] = -263,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "INFOS",
			["positionx"] = 752,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["anchor3"] = {
			["visible"] = true,
			["positiony"] = -62.5,
			["scale"] = 0.8,
			["width"] = 32,
			["info"] = "TIMERBARS 1",
			["positionx"] = 49.75,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["icons"] = {
			["fontSize"] = 13,
			["orderByTime"] = true,
			["decimal"] = false,
			["automatic"] = true,
			["showSpiral"] = 1,
			["inactiveAlpha"] = 0.3,
			["level"] = 10,
			["height2"] = 37,
			["colonne2"] = 8,
			["textsoffsets"] = {
				{
					["visible"] = true,
					["offsety"] = -2,
					["align"] = "TOP",
					["offsetx"] = 0,
					["size"] = 14,
				}, -- [1]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMRIGHT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [2]
				{
					["visible"] = true,
					["offsety"] = 1,
					["align"] = "BOTTOMLEFT",
					["offsetx"] = 1,
					["size"] = 10,
				}, -- [3]
			},
			["mode"] = "BLEND",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["growup"] = false,
			["pointpa"] = true,
			["width"] = 37,
			["height"] = 37,
			["pulse"] = 1.6,
			["enable"] = true,
			["activeAlpha"] = 1,
			["width2"] = 37,
			["speed"] = 4,
			["colonne"] = 8,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["blood"] = {
			["persistence"] = 6,
			["level"] = 1,
			["NotInRaid"] = true,
			["enable"] = true,
			["mode"] = "BLEND",
			["alpha"] = 0.7,
			["size"] = 0.7,
		},
		["anchor4"] = {
			["visible"] = true,
			["positiony"] = -4,
			["scale"] = 0.75,
			["width"] = 32,
			["info"] = "TIMERBARS 2",
			["positionx"] = 206,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["reportkickchan"] = "NONE",
		["anchor7"] = {
			["visible"] = true,
			["positiony"] = -145,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "ICONS 2",
			["positionx"] = 229,
			["height"] = 32,
			["level"] = 1,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["haveTarget"] = false,
		["alignToGrid"] = true,
		["inCombat"] = false,
		["configname"] = "[BuildIn] Minimalistic",
		["roundMethod"] = true,
		["combo"] = {
			["fontSize"] = 18,
			["positiony"] = -18.7654760151932,
			["enable"] = true,
			["textOffsetX"] = 12,
			["impulsion"] = 1.2,
			["level"] = 12,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\combo.tga",
			["textures"] = {
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_gray.tga", -- [1]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_yellow.tga", -- [2]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_gray.tga", -- [3]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_square_red.tga", -- [4]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga", -- [5]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_rune_blood.tga", -- [6]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga", -- [7]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_rune_frost.tga", -- [8]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga", -- [9]
				"Interface\\AddOns\\DroodFocus\\custom\\combo_rune_unholy.tga", -- [10]
				[13] = "Interface\\AddOns\\DroodFocus\\custom\\combo_closeEye.tga",
				[14] = "Interface\\AddOns\\DroodFocus\\custom\\combo_holy.tga",
			},
			["angleA"] = 288,
			["offsety"] = 0,
			["ptype"] = 1,
			["angleB"] = 183,
			["form"] = {
				false, -- [1]
				true, -- [2]
				false, -- [3]
				true, -- [4]
				false, -- [5]
				false, -- [6]
				false, -- [7]
			},
			["mode"] = "BLEND",
			["width"] = 22,
			["offsetx"] = 22,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showText"] = false,
			["textOffsetY"] = -17,
			["height"] = 16,
			["positionx"] = 46.48171903088996,
			["rayon"] = 37,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["anchor0"] = {
			["visible"] = true,
			["positiony"] = 289,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "GLOBAL",
			["positionx"] = 625,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["cooldown"] = {
			["offsety"] = -48,
			["positiony"] = -1.000137314198355,
			["enable"] = true,
			["alpha"] = 0.7,
			["width"] = 49,
			["positionx"] = 199.9999970197678,
			["mode"] = "BLEND",
			["height"] = 49,
			["level"] = 5,
			["offsetx"] = 0,
			["temps"] = 3,
		},
		["anchor6"] = {
			["visible"] = true,
			["positiony"] = -23,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "CD",
			["level"] = 10,
			["height"] = 32,
			["positionx"] = -4,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["reportkick"] = true,
		["targetbar"] = {
			["fontSize"] = 9,
			["positiony"] = -50,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#M k (#p%) #t",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["textx"] = -4,
			["width"] = 192,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.75,
				["r"] = 1,
			},
			["positionx"] = 10,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 13,
			["textAlign"] = "RIGHT",
			["texty"] = 0,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["infos"] = {
			["fontSize"] = 8,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["infolines"] = "PA: #meleeAP (#maxAP)*CC: #meleeCrit (#maxCrit%)*HASTE: #meleeHaste",
			["enable"] = false,
			["level"] = 12,
			["backColor"] = {
				["a"] = 0,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["textColor"] = {
				["a"] = 0.4600000381469727,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["minimap"] = true,
		["anchor2"] = {
			["visible"] = true,
			["positiony"] = -16,
			["scale"] = 0.8,
			["width"] = 32,
			["info"] = "ICONS 1",
			["level"] = 1,
			["height"] = 32,
			["positionx"] = 50,
			["mode"] = "BLEND",
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["configversion"] = 433,
		["uiAlwaysShow"] = false,
		["timerbar"] = {
			["activeAlpha"] = 1,
			["cdColor"] = {
				["a"] = 0.4900000095367432,
				["b"] = 0,
				["v"] = 1,
				["r"] = 1,
			},
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["inactiveAlpha"] = 0,
			["level"] = 4,
			["height2"] = "22",
			["prop2"] = true,
			["growup"] = false,
			["font1Size"] = 12,
			["timeline"] = 14,
			["cdoffsety"] = 2,
			["height"] = "22",
			["activeAlpha2"] = 1,
			["orderByTime"] = true,
			["enable"] = true,
			["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["showSpark"] = true,
			["prop"] = true,
			["borderSize"] = 1,
			["activeAlphaCD"] = 1,
			["cdoffsetx"] = 0,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["textsoffsets"] = {
				{
					["offsety"] = 1,
					["offsetx"] = 0,
				}, -- [1]
				{
					["offsety"] = 0,
					["offsetx"] = 2,
				}, -- [2]
			},
			["activeAlphaCD2"] = 1,
			["stackup2"] = true,
			["width"] = "257.25",
			["inactiveAlpha2"] = 0,
			["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["stackup1"] = false,
			["font2Size"] = 20,
			["width2"] = "257.25",
			["showTimeLine"] = true,
			["border"] = true,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["gridSizeY"] = 1,
		["gps"] = {
			["fontSize"] = 10,
			["gpsTarget"] = {
				"target", -- [1]
				"focus", -- [2]
			},
			["positiony"] = 202.6987448411231,
			["enable"] = true,
			["offsety"] = -16,
			["alpha"] = 1,
			["width"] = 28,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["positionx"] = 0,
			["level"] = 10,
			["mode"] = "BLEND",
			["height"] = 28,
			["offsetx"] = 0,
			["positions"] = {
				{
					["y"] = 132.2756708771094,
					["x"] = 619.3742247537051,
				}, -- [1]
				{
					["y"] = 132.1997336864121,
					["x"] = 553.0041571918996,
				}, -- [2]
				{
				}, -- [3]
			},
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["anchor1"] = {
			["visible"] = true,
			["positiony"] = -36,
			["scale"] = 0.8,
			["width"] = 32,
			["info"] = "UI",
			["mode"] = "BLEND",
			["height"] = 32,
			["level"] = 1,
			["positionx"] = 48,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["defensebar"] = {
			["fontSize"] = 11,
			["positiony"] = 97,
			["enable"] = true,
			["border"] = false,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar5.tga",
			["sformat"] = "#C k/#M k",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				false, -- [1]
				true, -- [2]
				false, -- [3]
				false, -- [4]
				false, -- [5]
				false, -- [6]
				false, -- [7]
				false, -- [8]
			},
			["color"] = {
				["a"] = 0.7900000065565109,
				["b"] = 0.9686274509803922,
				["v"] = 1,
				["r"] = 0.5372549019607843,
			},
			["width"] = 149,
			["textx"] = -4,
			["positionx"] = 29,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 20,
			["textAlign"] = "CENTER",
			["texty"] = -1,
			["textColor"] = {
				["a"] = 1,
				["b"] = 0.7803921568627451,
				["v"] = 0.7803921568627451,
				["r"] = 0.7803921568627451,
			},
		},
		["castbar"] = {
			["positiony"] = 77,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["activeAlpha"] = 1,
			["timerAlign"] = "RIGHT",
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["inactiveAlpha"] = 0,
			["level"] = 3,
			["timery"] = 0,
			["textx"] = 3,
			["sound1"] = "Interface\\AddOns\\DroodFocus\\datas\\DF_alert.ogg",
			["showText"] = true,
			["height"] = 24,
			["positionx"] = 10,
			["sound2"] = "",
			["fontSize"] = 12,
			["colori"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0,
				["b"] = 0,
			},
			["enable"] = true,
			["timerx"] = -3,
			["borderSize"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["showSpark"] = true,
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["timerColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
			["textAlign"] = "LEFT",
			["width"] = 192,
			["impulsion"] = 1,
			["fontSizetimer"] = 16,
			["fontPathtimer"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
			["border"] = true,
			["orientation"] = "HORIZONTAL",
			["texty"] = 0,
			["showTimer"] = true,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["manabar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 0,
				["r"] = 0,
			},
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["enable"] = false,
			["width"] = 192,
			["textx"] = -7,
			["positionx"] = 8,
			["showText"] = true,
			["height"] = 18,
			["orientation"] = "HORIZONTAL",
			["textAlign"] = "RIGHT",
			["texty"] = 1,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["spells"] = {
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 77758,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "77758",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["ids"] = {
					77758, -- [1]
				},
				["FX_textoffsetx"] = 0,
				["FX_timerposy"] = 0,
				["abiSpelltext"] = "Rosser",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_rotatespeed"] = 0,
				["FX_timersmall"] = true,
				["abiEnd"] = 0,
				["FX_stack"] = 0,
				["FX_name"] = "Custom",
				["perso"] = true,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["strongcheck"] = false,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textalign"] = "CENTER",
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_customtexture"] = "",
				["names"] = {
					"Rosser", -- [1]
				},
				["FX_timerenable"] = false,
				["abiFake"] = 0,
				["showdottimer"] = true,
				["FX_end_posx"] = 0,
				["FX_timeralpha"] = 0.35,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["comboPoints"] = 0,
				["height"] = 32,
				["abiRdyMode"] = false,
				["FX_middle_width"] = 1,
				["FX_end_scale"] = 0.5,
				["FX_start_scale"] = 0.5,
				["FX_textoffsety"] = -40,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_middle_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["abiLast"] = 0,
				["FX_start_posx"] = 0,
				["FX_start_posy"] = 0,
			}, -- [1]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 90166,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					90166, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
					["0x06800000028F0E48"] = 0,
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "90166",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiLast"] = 25758.316,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0.009999999998399289,
				["FX_chakerpower"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_textenabled"] = false,
				["FX_middle_scale"] = 1,
				["FX_start_posy"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_textalign"] = "CENTER",
				["FX_timersmall"] = true,
				["FX_rotatespeed"] = 0,
				["FX_middle_posx"] = 0,
				["FX_name"] = "Custom",
				["showdottimer"] = true,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_middle_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["r"] = 1,
					["v"] = 1,
					["b"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_start_height"] = 1,
				["names"] = {
					"Force de la panthère", -- [1]
				},
				["FX_stack"] = 0,
				["abiFake"] = 0,
				["FX_end_posx"] = 0,
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["height"] = 32,
				["abiRdyMode"] = false,
				["FX_middle_width"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_end_scale"] = 0.5,
				["abiDuration"] = 0,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["abiEnd"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["abiSpelltext"] = "Force de la panthère",
				["FX_start_posx"] = 0,
				["showcd"] = true,
			}, -- [2]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 80951,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					80951, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "80951",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["abiSpelltext"] = "Pulvérisation",
				["FX_start_posy"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_middle_scale"] = 1,
				["FX_textalign"] = "CENTER",
				["FX_end_scale"] = 0.5,
				["sType"] = "BuffPlayer",
				["FX_timersmall"] = true,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_start_alpha"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_end_posx"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textenabled"] = false,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["names"] = {
					"Pulvérisation", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_middle_posx"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_textoffsety"] = -40,
				["FX_mode"] = "BLEND",
				["FX_rotatespeed"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["abiLast"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["timerbar"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [3]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 263.0980000000018,
				["abiSpellId"] = 91565,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Feu féerique",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
					["0xF13079A8000072D3"] = 16694,
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "91565;7386;8647;35387;50498;770",
				["abiStack"] = 3,
				["FX_start_posy"] = 0,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["abiAlert"] = false,
				["FX_timerscale"] = 0.4,
				["ids"] = {
					91565, -- [1]
					7386, -- [2]
					8647, -- [3]
					35387, -- [4]
					50498, -- [5]
					770, -- [6]
				},
				["timerbar"] = 1,
				["showdottimer"] = true,
				["FX_end_scale"] = 0.5,
				["abiLast"] = 0,
				["FX_timersmall"] = true,
				["FX_middle_posx"] = 0,
				["FX_start_alpha"] = 0,
				["FX_customtexture"] = "",
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 263.0980000000018,
				["FX_mode"] = "BLEND",
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["abiStart"] = 25738.987,
				["FX_middle_height"] = 1,
				["FX_middle_scale"] = 1,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["height"] = 32,
				["names"] = {
					"Feu féerique", -- [1]
					"Fracasser armure", -- [2]
					"Exposer l'armure", -- [3]
					"Crachat corrosif", -- [4]
					"Déchirer armure", -- [5]
					"Lucioles", -- [6]
				},
				["FX_middle_width"] = 1,
				["FX_pulsespeedZ"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_textoffsety"] = -40,
				["FX_timeralpha"] = 0.35,
				["abiEnd"] = 26038.987,
				["comboPoints"] = 0,
				["abiDuration"] = 300,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["perso"] = true,
				["FX_timerenable"] = false,
				["FX_rotatespeed"] = 0,
				["form"] = {
					true, -- [1]
					true, -- [2]
					true, -- [3]
					true, -- [4]
					true, -- [5]
					true, -- [6]
					true, -- [7]
					true, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_pulsepowerX"] = 0,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [4]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 81022,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 20,
				["FX_customtexture"] = "",
				["positionx"] = 64,
				["FX_positionx"] = 70,
				["abiWarn"] = 0,
				["FX_angle"] = 19,
				["FX_height"] = 160,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 0.2,
				["FX_width"] = 160,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = true,
				["FX_middle_scale"] = 1,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "81022",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["abiLast"] = 0,
				["FX_start_width"] = 0.2,
				["abiCD"] = 0,
				["abiLastCd"] = 28.1309999999994,
				["FX_chakerpower"] = 1,
				["FX_rotatespeed"] = 0,
				["FX_start_posy"] = 0,
				["showdottimer"] = true,
				["timerbar"] = 0,
				["abiEnd"] = 0,
				["FX_end_scale"] = 1,
				["sType"] = "BuffPlayer",
				["FX_timersmall"] = false,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_name"] = "FromRight",
				["FX_timerscale"] = 0.85,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_middle_posx"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["ids"] = {
					81022, -- [1]
				},
				["FX_pulsepowerZ"] = 0.2,
				["FX_start_scale"] = 1,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_pulsespeedZ"] = 16,
				["names"] = {
					"Ruée", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_start_height"] = 1,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\custom\\tiger",
				["abiDuration"] = 0,
				["FX_timeralpha"] = 0.25,
				["FX_timerposy"] = 0,
				["comboPoints"] = 0,
				["FX_textoffsety"] = -18,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_mode"] = "BLEND",
				["FX_timerenable"] = false,
				["showcd"] = true,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_end_posx"] = -160,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["abiSpelltext"] = "Ruée",
				["TimerLimit"] = 0,
				["FX_start_posx"] = 160,
				["FX_positiony"] = 243,
			}, -- [5]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 16870,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 128,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["FX_positionx"] = 72,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["abiSpelltext"] = "Idées claires",
				["FX_end_width"] = 1,
				["FX_width"] = 425,
				["FX_stack"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					16870, -- [1]
				},
				["FX_middle_scale"] = 1.75,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "16870",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0.771999999999025,
				["FX_chakerpower"] = 1,
				["FX_timerposy"] = 0,
				["FX_start_posy"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_textoffsetx"] = 0,
				["timerbar"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx_ooc.tga",
				["FX_customtexture"] = "",
				["FX_timersmall"] = true,
				["FX_end_scale"] = 3,
				["FX_name"] = "Custom",
				["perso"] = true,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["FX_textalign"] = "CENTER",
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textenabled"] = false,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_end_posx"] = 0,
				["names"] = {
					"Idées claires", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_mode"] = "ADD",
				["combo"] = false,
				["abiEnd"] = 0,
				["FX_timeralpha"] = 0.35,
				["abiLast"] = 0,
				["comboPoints"] = 0,
				["FX_start_scale"] = 0,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_textoffsety"] = -40,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["form"] = {
					true, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					true, -- [6]
					false, -- [7]
					true, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_middle_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_rotatespeed"] = 0.5,
				["FX_height"] = 96,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 66,
			}, -- [6]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 33745,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["FX_customtexture"] = "",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["TimerLimit"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_pulsespeedZ"] = 0,
				["ids"] = {
					33745, -- [1]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "33745",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_middle_scale"] = 1,
				["FX_textoffsetx"] = 0,
				["FX_start_posy"] = 0,
				["FX_height"] = 128,
				["abiLast"] = 0,
				["FX_end_scale"] = 0.5,
				["FX_textalign"] = "CENTER",
				["FX_timersmall"] = true,
				["FX_textenabled"] = false,
				["FX_name"] = "Custom",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["height"] = 32,
				["showdottimer"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["abiEnd"] = 0,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = true,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_middle_posx"] = 0,
				["names"] = {
					"Lacérer", -- [1]
				},
				["FX_middle_width"] = 1,
				["perso"] = true,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["FX_stack"] = 0,
				["comboPoints"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_mode"] = "BLEND",
				["FX_start_scale"] = 0.5,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["sType"] = "DebuffTarget",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_rotatespeed"] = 0,
				["abiSpelltext"] = "Lacérer",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [7]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 26.72200000000157,
				["abiSpellId"] = 33876,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Mutilation",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
					["0xF13079A8000072D3"] = 16694,
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_textalign"] = "CENTER",
				["FX_end_alpha"] = 0,
				["spellIDs"] = "33878;33876;46857;50271;35290;16511",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["showdottimer"] = true,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_pulsepowerX"] = 0,
				["FX_start_posy"] = 0,
				["ids"] = {
					33878, -- [1]
					33876, -- [2]
					46857, -- [3]
					50271, -- [4]
					35290, -- [5]
					16511, -- [6]
				},
				["FX_rotatespeed"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["abiEnd"] = 25802.611,
				["FX_timersmall"] = true,
				["FX_end_scale"] = 0.5,
				["FX_name"] = "Custom",
				["showcd"] = true,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_end_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 26.72200000000157,
				["height"] = 32,
				["FX_customtexture"] = "",
				["abiStart"] = 25742.611,
				["FX_middle_height"] = 1,
				["FX_stack"] = 0,
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_timerscale"] = 0.4,
				["names"] = {
					"Mutilation", -- [1]
					"Mutilation", -- [2]
					"Traumatisme", -- [3]
					"Déchirure du tendon", -- [4]
					"Encorner", -- [5]
					"Hémorragie", -- [6]
				},
				["FX_middle_width"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_mode"] = "BLEND",
				["FX_timerenable"] = false,
				["FX_timeralpha"] = 0.35,
				["perso"] = false,
				["comboPoints"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiDuration"] = 60,
				["FX_end_posx"] = 0,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 26,
				},
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["FX_middle_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_middle_scale"] = 1,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [8]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 52610,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["FX_pulsepowerX"] = 0,
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
					["0x06800000028F0E48"] = 0,
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "52610",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["abiLast"] = 25758.316,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 22.40299999999843,
				["FX_chakerpower"] = 0,
				["FX_timerposy"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["ids"] = {
					52610, -- [1]
				},
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timersmall"] = true,
				["showcd"] = true,
				["FX_name"] = "Custom",
				["FX_middle_scale"] = 1,
				["FX_middle_posy"] = 0,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["perso"] = true,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["showdottimer"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_stack"] = 0,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_start_scale"] = 0.5,
				["names"] = {
					"Rugissement sauvage", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_end_scale"] = 0.5,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textalign"] = "CENTER",
				["FX_timeralpha"] = 0.35,
				["FX_customtexture"] = "",
				["comboPoints"] = 0,
				["FX_start_height"] = 1,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["height"] = 32,
				["combo"] = false,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_start_alpha"] = 0,
				["sType"] = "BuffPlayer",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["TimerLimit"] = 0,
				["abiSpelltext"] = "Rugissement sauvage",
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [9]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 99,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["FX_positionx"] = 165,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Rugissement démoralisant",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_textoffsetx"] = 0,
				["ids"] = {
					99, -- [1]
					1160, -- [2]
					702, -- [3]
					26017, -- [4]
				},
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "99;1160;702;26017",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_start_posy"] = 0,
				["TimerLimit"] = 0,
				["FX_middle_scale"] = 1,
				["sType"] = "DebuffTarget",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_customtexture"] = "",
				["FX_timersmall"] = true,
				["FX_end_scale"] = 0.5,
				["FX_start_alpha"] = 0,
				["showdottimer"] = true,
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["FX_stack"] = 0,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["combo"] = false,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["FX_timerenable"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textenabled"] = false,
				["names"] = {
					"Rugissement démoralisant", -- [1]
					"Cri démoralisant", -- [2]
					"Malédiction de faiblesse", -- [3]
					"Justification", -- [4]
				},
				["FX_middle_width"] = 1,
				["perso"] = true,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["showcd"] = true,
				["FX_timeralpha"] = 0.35,
				["FX_middle_posx"] = 0,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_start_scale"] = 0.5,
				["FX_textoffsety"] = -40,
				["height"] = 32,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_textalign"] = "CENTER",
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_pulsepowerX"] = 0,
				["FX_pulsespeedZ"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 179,
			}, -- [10]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1079,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["abiEnd"] = 0,
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Déchirure",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
					["0xF13079A8000072D3"] = 0,
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "1079",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["FX_middle_posx"] = 0,
				["abiLast"] = 0,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_pulsepowerX"] = 0,
				["abiAlert"] = false,
				["FX_timerposy"] = 0,
				["FX_end_posx"] = 0,
				["FX_end_scale"] = 0.5,
				["showdottimer"] = true,
				["FX_timersmall"] = true,
				["FX_middle_scale"] = 1,
				["ids"] = {
					1079, -- [1]
				},
				["FX_start_alpha"] = 0,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["FX_middle_posy"] = 0,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_timerenable"] = false,
				["FX_pulsepowerZ"] = 0,
				["abiDuration"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_textoffsety"] = -40,
				["names"] = {
					"Déchirure", -- [1]
				},
				["FX_customtexture"] = "",
				["FX_middle_width"] = 1,
				["FX_textalign"] = "CENTER",
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timeralpha"] = 0.35,
				["FX_start_scale"] = 0.5,
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = false,
				["abiFake"] = 2,
				["height"] = 32,
				["sType"] = "DebuffTarget",
				["showcd"] = true,
				["FX_end_posy"] = 0,
				["strongcheck"] = false,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_timerabove"] = false,
				["luaCode"] = "local current = UnitHealth(\"target\")\nlocal maxi = UnitHealthMax(\"target\")\nif maxi>0 then\n  percent = current/maxi\n  if percent<=0.25 or maxi<50000 then\n    DF_namespace:icon_setTexture(DF_abiNum,\"Interface\\\\icons\\\\ability_druid_ferociousbite\")\n  else\n    DF_namespace:icon_setTexture(DF_abiNum,\"Interface\\\\icons\\\\ability_ghoulfrenzy\")\n  end\nelse\n  DF_namespace:icon_setTexture(DF_abiNum,\"Interface\\\\icons\\\\ability_ghoulfrenzy\")\nend\nreturn true",
				["timerbar"] = 0,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_pulsespeedZ"] = 0,
			}, -- [11]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = false,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 1822,
				["FX_timerposx"] = 0,
				["icon"] = 1,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 40,
				["sType"] = "DebuffTarget",
				["positionx"] = 64,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 128,
				["abiSpelltext"] = "Griffure",
				["FX_end_width"] = 1,
				["FX_width"] = 128,
				["timerbar"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = false,
				["FX_timerposy"] = 0,
				["FX_pulsespeedX"] = 0,
				["abiPower"] = {
					["0xF13079A8000072D3"] = 0,
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.4,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "1822",
				["abiStack"] = 0,
				["FX_start_posy"] = 0,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 1,
				},
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 0,
				["FX_chakerpower"] = 0,
				["FX_rotatespeed"] = 0,
				["FX_pulsepowerX"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["FX_customtexture"] = "",
				["FX_timersmall"] = true,
				["ids"] = {
					1822, -- [1]
				},
				["FX_middle_posx"] = 0,
				["FX_start_alpha"] = 0,
				["showdottimer"] = true,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["strongcheck"] = false,
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["form"] = {
					false, -- [1]
					false, -- [2]
					false, -- [3]
					true, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_pulsepowerZ"] = 0,
				["FX_start_scale"] = 0.5,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -40,
				["FX_middle_scale"] = 1,
				["names"] = {
					"Griffure", -- [1]
				},
				["abiDuration"] = 0,
				["FX_middle_width"] = 1,
				["height"] = 32,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\datas\\fx.tga",
				["FX_timeralpha"] = 0.35,
				["FX_textalign"] = "CENTER",
				["comboPoints"] = 0,
				["perso"] = true,
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_timerenable"] = false,
				["abiLast"] = 0,
				["abiEnd"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "Custom",
				["FX_end_scale"] = 0.5,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_stack"] = 0,
				["TimerLimit"] = 0,
				["FX_start_posx"] = 0,
				["FX_pulsespeedZ"] = 0,
			}, -- [12]
			{
				["abiDotIndex"] = 0,
				["positiony"] = 64,
				["FX_enable"] = true,
				["removable"] = true,
				["FX_textsize"] = 12,
				["abiOldTimeLeft"] = 0,
				["abiSpellId"] = 62606,
				["FX_timerposx"] = 0,
				["icon"] = 0,
				["abiAlphaPulse"] = 0,
				["FX_middle_alpha"] = 1,
				["abiInternalCD"] = 0,
				["FX_speed"] = 70,
				["sType"] = "BuffPlayer",
				["positionx"] = 64,
				["FX_positionx"] = 68,
				["abiWarn"] = 0,
				["FX_angle"] = 0,
				["FX_height"] = 260,
				["FX_pulsepowerX"] = 1,
				["FX_end_width"] = 1,
				["FX_width"] = 250,
				["FX_stack"] = 0,
				["FX_textoffsetx"] = 0,
				["FX_textenabled"] = true,
				["FX_rotatespeed"] = 0,
				["FX_pulsespeedX"] = 1.5,
				["abiPower"] = {
				},
				["FX_pulsepowerY"] = 0,
				["abiSound"] = "",
				["FX_timerscale"] = 0.85,
				["FX_end_alpha"] = 0,
				["spellIDs"] = "62606",
				["abiStack"] = 0,
				["abiAlert"] = false,
				["FX_end_posx"] = 0,
				["showcd"] = true,
				["FX_start_width"] = 1,
				["abiCD"] = 0,
				["abiLastCd"] = 3.635999999998603,
				["FX_chakerpower"] = 0,
				["FX_timerposy"] = 0,
				["abiSpelltext"] = "Défense sauvage",
				["TimerLimit"] = 0,
				["timerbar"] = 0,
				["FX_middle_scale"] = 1.25,
				["FX_end_scale"] = 3,
				["ids"] = {
					62606, -- [1]
				},
				["FX_timersmall"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["v"] = 0,
					["b"] = 0,
				},
				["FX_start_alpha"] = 0,
				["FX_texture"] = "Interface\\AddOns\\DroodFocus\\custom\\bubble",
				["strongcheck"] = false,
				["FX_pulsespeedY"] = 0,
				["FX_end_height"] = 1,
				["form"] = {
					false, -- [1]
					true, -- [2]
					false, -- [3]
					false, -- [4]
					false, -- [5]
					false, -- [6]
					false, -- [7]
					false, -- [8]
					["TimerLimit"] = 0,
				},
				["FX_start_height"] = 1,
				["abiTimeLeft"] = 0,
				["FX_mode"] = "BLEND",
				["showdottimer"] = true,
				["abiStart"] = 0,
				["FX_middle_height"] = 1,
				["FX_customtexture"] = "",
				["FX_pulsepowerZ"] = 0.3,
				["FX_start_scale"] = 0,
				["combo"] = false,
				["abiUserText"] = "",
				["FX_textoffsety"] = -49,
				["abiEnd"] = 0,
				["names"] = {
					"Défense sauvage", -- [1]
				},
				["FX_middle_width"] = 1,
				["FX_textalign"] = "CENTER",
				["perso"] = true,
				["height"] = 32,
				["FX_timeralpha"] = 0.25,
				["abiLast"] = 0,
				["comboPoints"] = 0,
				["FX_fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font_unispace.ttf",
				["abiRdyMode"] = false,
				["abiFake"] = 0,
				["FX_textColor"] = {
					["a"] = 0.5,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["FX_timerenable"] = false,
				["abiDuration"] = 0,
				["FX_end_posy"] = 0,
				["FX_middle_posy"] = 0,
				["width"] = 32,
				["FX_name"] = "HeartBeat",
				["FX_middle_posx"] = 0,
				["FX_timerabove"] = false,
				["luaCode"] = "",
				["FX_pulsespeedZ"] = 10,
				["FX_start_posy"] = 0,
				["FX_start_posx"] = 0,
				["FX_positiony"] = 185,
			}, -- [13]
		},
		["anchor8"] = {
			["visible"] = true,
			["positiony"] = -128,
			["scale"] = 1,
			["width"] = 32,
			["info"] = "DOTS",
			["positionx"] = 128,
			["height"] = 32,
			["mode"] = "BLEND",
			["level"] = 1,
			["texture"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
		},
		["cursorspeed"] = 30,
		["healthbar"] = {
			["fontSize"] = 12,
			["positiony"] = 40,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["colorBad"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 1,
			},
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["colorDef"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["sformat"] = "#C k/#M k (#p%) #t",
			["colorAverage"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.5,
				["r"] = 1,
			},
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["colorchg"] = true,
			["textx"] = -7,
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["colorGood"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 1,
				["r"] = 0,
			},
			["width"] = 192,
			["textAlign"] = "RIGHT",
			["orientation"] = "HORIZONTAL",
			["showText"] = true,
			["texty"] = 1,
			["height"] = 18,
			["positionx"] = 8,
			["level"] = 2,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
		["ooc"] = {
			["spell"] = 12536,
			["positiony"] = 17,
			["scaleMin"] = 1,
			["positionx"] = 70,
			["width"] = "650",
			["textureOff"] = "Interface\\AddOns\\DroodFocus\\datas\\empty.tga",
			["mode"] = "ADD",
			["scaleMax"] = 0.1,
			["textureOn"] = "Interface\\AddOns\\DroodFocus\\datas\\ooc.tga",
			["height"] = "150",
			["level"] = 10,
			["speed"] = 0.1,
			["enable"] = true,
		},
		["timerbars"] = {
			{
				["orderByTime"] = false,
				["enable"] = true,
				["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["showSpark"] = true,
				["prop"] = true,
				["borderSize"] = 1,
				["cdColor"] = {
					["a"] = 0.9400000013411045,
					["b"] = 0,
					["v"] = 1,
					["r"] = 1,
				},
				["showTimeLine"] = true,
				["activeAlphaCD"] = 0.6,
				["level"] = 4,
				["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
				["stackup1"] = false,
				["border"] = true,
				["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
				["cdoffsetx"] = 0,
				["growup"] = true,
				["height"] = 15,
				["font1Size"] = 9,
				["width"] = 192,
				["borderColor"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 0,
				},
				["textsoffsets"] = {
					{
						["offsety"] = 1,
						["offsetx"] = 0,
					}, -- [1]
					{
						["offsety"] = 0,
						["offsetx"] = 2,
					}, -- [2]
				},
				["cdoffsety"] = 2,
				["timeline"] = 14,
				["font2Size"] = 16,
				["activeAlpha"] = 1,
				["inactiveAlpha"] = 1,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
			}, -- [1]
			{
				["orderByTime"] = true,
				["enable"] = true,
				["font1Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["showSpark"] = true,
				["prop"] = true,
				["borderSize"] = 1,
				["cdColor"] = {
					["a"] = 0.9299999997019768,
					["b"] = 0,
					["v"] = 1,
					["r"] = 1,
				},
				["showTimeLine"] = true,
				["activeAlphaCD"] = 0.6,
				["level"] = 4,
				["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
				["stackup1"] = true,
				["border"] = true,
				["font2Path"] = "Interface\\AddOns\\DroodFocus\\datas\\font_digital.ttf",
				["cdoffsetx"] = 0,
				["growup"] = false,
				["height"] = 18,
				["font1Size"] = 9,
				["width"] = 184,
				["borderColor"] = {
					["a"] = 1,
					["b"] = 0,
					["v"] = 0,
					["r"] = 0,
				},
				["textsoffsets"] = {
					{
						["offsety"] = 1,
						["offsetx"] = 0,
					}, -- [1]
					{
						["offsety"] = 0,
						["offsetx"] = 2,
					}, -- [2]
				},
				["cdoffsety"] = 2,
				["timeline"] = 14,
				["font2Size"] = 16,
				["activeAlpha"] = 1,
				["inactiveAlpha"] = 0,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
			}, -- [2]
		},
		["TimerLimit"] = 0,
		["iconbars"] = {
			{
				["fontSize"] = 13,
				["orderByTime"] = true,
				["decimal"] = false,
				["automatic"] = true,
				["spacex"] = 39,
				["spacey"] = 39,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["timerformat"] = false,
				["pulsecd"] = false,
				["mode"] = "BLEND",
				["inactiveCDAlpha"] = 0.3,
				["height2"] = 37,
				["height"] = 36,
				["activeAlpha"] = 1,
				["textsoffsets"] = {
					{
						["visible"] = true,
						["offsety"] = -2,
						["align"] = "TOPLEFT",
						["offsetx"] = 1,
						["size"] = 14,
					}, -- [1]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMRIGHT",
						["offsetx"] = 0,
						["size"] = 10,
					}, -- [2]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMLEFT",
						["offsetx"] = 2,
						["size"] = 10,
					}, -- [3]
				},
				["inactiveAlpha"] = 0.3,
				["growup"] = false,
				["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["pointpa"] = true,
				["width"] = 36,
				["pulse"] = 1.2,
				["showSpiral"] = 1,
				["colonne"] = 8,
				["level"] = 10,
				["width2"] = 37,
				["speed"] = 4,
				["enable"] = true,
				["colonne2"] = 8,
			}, -- [1]
			{
				["fontSize"] = 13,
				["orderByTime"] = true,
				["decimal"] = false,
				["automatic"] = true,
				["spacex"] = 39,
				["spacey"] = 39,
				["textColor"] = {
					["a"] = 1,
					["b"] = 1,
					["v"] = 1,
					["r"] = 1,
				},
				["pulsecd"] = false,
				["timerformat"] = false,
				["level"] = 10,
				["inactiveCDAlpha"] = 0.5,
				["height2"] = 37,
				["height"] = 37,
				["activeAlpha"] = 1,
				["textsoffsets"] = {
					{
						["visible"] = true,
						["offsety"] = -2,
						["align"] = "TOP",
						["offsetx"] = 0,
						["size"] = 14,
					}, -- [1]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMRIGHT",
						["offsetx"] = 1,
						["size"] = 10,
					}, -- [2]
					{
						["visible"] = true,
						["offsety"] = 1,
						["align"] = "BOTTOMLEFT",
						["offsetx"] = 1,
						["size"] = 10,
					}, -- [3]
				},
				["growup"] = false,
				["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
				["showSpiral"] = 1,
				["pointpa"] = true,
				["width"] = 37,
				["pulse"] = 1.6,
				["speed"] = 4,
				["colonne"] = 20,
				["enable"] = true,
				["width2"] = 37,
				["mode"] = "BLEND",
				["inactiveAlpha"] = 1,
				["colonne2"] = 8,
			}, -- [2]
		},
		["eclipsebar"] = {
			["fontSize"] = 12,
			["positiony"] = 140,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0,
				["b"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#C k/#M k (#p%)",
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["v"] = 0.5,
				["b"] = 1,
			},
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["texty"] = 1,
			["width"] = 192,
			["color2"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 0.5,
				["b"] = 0,
			},
			["textAlign"] = "RIGHT",
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 18,
			["positionx"] = 8,
			["textx"] = -7,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["alert"] = {
			["fontSize"] = 10,
			["positiony"] = 358,
			["enable"] = true,
			["texture3"] = "Interface\\AddOns\\DroodFocus\\datas\\alertSkull.tga",
			["showDebuff"] = true,
			["mode"] = "BLEND",
			["textOffsetX"] = 0,
			["texture2"] = "Interface\\AddOns\\DroodFocus\\datas\\alertRange.tga",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["width"] = 100,
			["alpha"] = 0.5,
			["showBuff"] = false,
			["texture1"] = "Interface\\AddOns\\DroodFocus\\datas\\alertBehind.tga",
			["persistence"] = 1.5,
			["showText"] = true,
			["textOffsetY"] = -36,
			["height"] = 100,
			["positionx"] = 616,
			["level"] = 5,
			["textColor"] = {
				["a"] = 1,
				["r"] = 1,
				["v"] = 1,
				["b"] = 1,
			},
		},
		["petbar"] = {
			["fontSize"] = 11,
			["positiony"] = -6,
			["enable"] = false,
			["border"] = true,
			["borderSize"] = 1,
			["borderColor"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0,
				["r"] = 0,
			},
			["level"] = 2,
			["texturePath"] = "Interface\\AddOns\\DroodFocus\\datas\\statusbar.tga",
			["sformat"] = "#M k (#p%)",
			["fontPath"] = "Interface\\AddOns\\DroodFocus\\datas\\font.ttf",
			["form"] = {
				true, -- [1]
				true, -- [2]
				true, -- [3]
				true, -- [4]
				true, -- [5]
				true, -- [6]
				true, -- [7]
				true, -- [8]
			},
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["v"] = 0.2,
				["r"] = 1,
			},
			["width"] = 192,
			["textx"] = -4,
			["positionx"] = 10,
			["showText"] = true,
			["orientation"] = "HORIZONTAL",
			["height"] = 13,
			["textAlign"] = "RIGHT",
			["texty"] = 0,
			["textColor"] = {
				["a"] = 1,
				["b"] = 1,
				["v"] = 1,
				["r"] = 1,
			},
		},
	}, -- [11]
	
	-- FIN [BuildIn] DroodFocus Default
}

DF_sharemedia = {
}

DF_talents = {
}

